/*****************************************************************************
 * main.c: main xawdecode source
 *****************************************************************************
 * $Id: main.c,v 1.20 2003/07/09 12:23:31 alainjj Exp $
 *****************************************************************************
 * Copyright (C) 2001 Keuleu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 *****************************************************************************
 *
 * This software was based on xawtv. Those portions are
 * Copyright (C) 1997 Gerd Knorr <kraxel@cs.tu-berlin.de>
 *
 *****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>
#include <math.h>
#include <time.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/utsname.h>
#include <sys/stat.h>
#include <dlfcn.h>
#include <dirent.h>

#include "config.h"

#define ALEVT_ENABLED 1

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xmd.h>
#include <X11/keysym.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xatom.h>
#include <X11/Shell.h>
#include <X11/Xaw/XawInit.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Scrollbar.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/Box.h>
#ifdef HAVE_XPM
# include <X11/xpm.h>
#endif

#ifdef HAVE_LIBXXF86DGA
# ifdef  HAVE_XFREE86_4            /* In fact have XFree86 4.X.X */
#  include <X11/Xproto.h>
#  define XF86DGA_MAJOR_VERSION XDGA_MAJOR_VERSION
#  define XF86DGA_MINOR_VERSION XDGA_MINOR_VERSION
# endif
# include <X11/extensions/xf86dga.h>
# include <X11/extensions/xf86dgastr.h>
#endif

#ifdef HAVE_LIBXXF86VM
# include <X11/extensions/xf86vmode.h>
# include <X11/extensions/xf86vmstr.h>
#endif

#ifdef HAVE_LIBXDPMS
# include <X11/extensions/dpms.h>
# ifndef  HAVE_XFREE86_4
/* XFree 3.3.x has'nt prototypes for this ... */
Bool DPMSQueryExtension (Display *, int *, int *);
Bool DPMSCapable (Display *);
Status DPMSInfo (Display *, CARD16 *, BOOL *);
Status DPMSEnable (Display *);
Status DPMSDisable (Display *);
# endif 
#endif

#include "writefile.h"
#include "mixer.h"
#include "channel.h"
#include "channels.h"
#include "strtab.h"
#include "grab.h"
#include "x11.h"
#include "toolbox.h"
#include "wmhooks.h"
#include "lirc.h"
#include "file.h"
#ifdef ALEVT_ENABLED
# include "alevt.h"
extern int alevt_in_use;
#endif
#include "plugin.h"
#include "xawdecode.h"
#ifdef HAVE_XPM
# include "xawdecode.xpm"
#endif
#include "cpu_accel.h"
#include "memcpy.h"
#include "deinterlace.h"
#if defined(HAVE_DIVX4LINUX) || defined(HAVE_FFMPEG) || defined(HAVE_XVID)
#include "divx.h"
#include "divx_ui.h"
static int divx_pixmap_format = 0;
#endif

#define ONSCREEN_TIME       6000
#define TITLE_TIME          6000
#define ZAP_TIME            8000
#define CAP_TIME              20
#define SCAN_TIME            100
#define MUTE_TIME            100    /* 0.1 sec mute when switching channels*/

#define WIDTH_INC             64
#define HEIGHT_INC            48
#define LABEL_WIDTH         "16"
#define VIDMODE_DELAY        100    /* 0.1 sec */

/*--- public variables ----------------------------------------------------*/
PLUGIN *plugin = NULL;
void *hPlugin = NULL;

char *video_base;
int direct_video = 0;
int direct_xsize;
int noDGA = 0;

XtAppContext app_context;
Widget app_shell     = NULL;
Widget tv            = NULL;
Widget opt_shell     = NULL;
Widget opt_paned     = NULL;
Widget chan_shell    = NULL;
Widget conf_shell    = NULL;
Widget on_shell      = NULL;
Widget on_label      = NULL;
Widget c_norm        = NULL;
Widget c_input       = NULL;
Widget c_freq        = NULL;
Widget c_audio       = NULL;
Widget c_cap         = NULL;
Widget c_deinterlace = NULL;
Widget c_stayontop   = NULL;
Widget c_decoration  = NULL;
#if defined(HAVE_DIVX4LINUX) || defined(HAVE_FFMPEG) || defined(HAVE_XVID)
Widget divx_shell    = NULL;
Widget c_record      = NULL;
#endif
Widget s_bright      = NULL;
Widget s_color       = NULL;
Widget s_hue         = NULL;
Widget s_contrast    = NULL;
Widget s_volume      = NULL;
Widget chan_viewport = NULL;
Widget chan_box      = NULL;
Display *dpy;
XtWorkProcId idle_id = 0;

Boolean (*idle_grabdisplay) (XtPointer data);

int have_config = 0;
Atom wm_protocols[2], xawtv_remote, xawtv_station;
XtIntervalId title_timer, audio_timer, zap_timer, scan_timer, on_timer;
int pointer_on = 1, on_skip = 0;
int debug = 0;
int fs = 0;
int de = 1;
int fs_width, fs_height, fs_xoff, fs_yoff;
int window_width, window_height;
int pix_width = 128, pix_height = 96;
int bpp = 0;
char *ppmfile;
char *jpegfile;
extern char *sendername;
#ifdef HAVE_XV
int disable_xv = 0;
int cmdline_xv_img_port = 0;
#endif
int hwscan = 0;
int have_MMX = 0;
int memcpy_method = MEMCPY_PROBE;

int zap_start, zap_fast;

char modename[64];
char *progname;
int  lirc;
int xfree_ext = 1;
int have_dga = 0;
int have_vm = 0;

#ifdef HAVE_LIBXXF86VM
int vm_count;
XF86VidModeModeInfo **vm_modelines;
#endif

/*                  PAL  NTSC SECAM */
int maxwidth[]  = { 768, 640, 768 };
int maxheight[] = { 576, 480, 576 };

/*--- drivers -------------------------------------------------------------*/

#ifdef HAVE_DEVFS
struct device_t device = {"/dev/v4l/video", "/dev/v4l/vbi"};
#else
struct device_t device = {"/dev/video", "/dev/vbi"};
#endif

char *mixer = "line";

extern struct GRABBER grab_v4l;
extern struct GRABBER grab_dummy;
struct GRABBER *grabbers[] = {
  &grab_v4l,
  // uncomment the following line to test without a TV-card
  &grab_dummy,
};

int grabber;

/*--- channels ------------------------------------------------------------*/

struct STRTAB *cmenu = NULL;
char title[256];

int cur_color;
int cur_bright;
int cur_hue;
int cur_contrast;
int cur_capture;
int cur_deinterlace = DEINTERLACE_NONE;

int cur_mute = 0;
int cur_volume = 65535;

/*--- actions -------------------------------------------------------------*/

/* conf.c */
extern void create_editorwin ();
extern void editor_station_switched ();
extern void editor_list_update ();
extern void save_cb (Widget widget, XtPointer clientdata, XtPointer call_data);

void CloseMainAction (Widget, XEvent *, String *, Cardinal *);
void ShowtimeAction (Widget, XEvent *, String *, Cardinal *);
void SetResAction (Widget, XEvent *, String *, Cardinal *);
void SetBgAction (Widget, XEvent *, String *, Cardinal *);
void SetShadowAction (Widget, XEvent *, String *, Cardinal *);
void SetChannelAction (Widget, XEvent *, String *, Cardinal *);
void TuneAction (Widget, XEvent *, String *, Cardinal *);
void ScanAction (Widget, XEvent *, String *, Cardinal *);
void ChannelAction (Widget, XEvent *, String *, Cardinal *);
void VolumeAction (Widget, XEvent *, String *, Cardinal *);
void PointerAction (Widget, XEvent *, String *, Cardinal *);
void FullScreenAction (Widget, XEvent *, String *, Cardinal *);
void OptionsAction (Widget, XEvent *, String *, Cardinal *);
void ChannelsAction (Widget, XEvent *, String *, Cardinal *);
void EditorAction (Widget, XEvent *, String *, Cardinal *);
void RemoteAction (Widget, XEvent *, String *, Cardinal *);
void ZapAction (Widget, XEvent *, String *, Cardinal *);
void SnapAction (Widget, XEvent *, String *, Cardinal *);
void AleVTAction (Widget, XEvent *, String *, Cardinal *);
void StayOnTopAction (Widget, XEvent *, String *, Cardinal *);
void DecorationAction (Widget, XEvent *, String *, Cardinal *);
void DeinterlaceAction (Widget, XEvent *, String *, Cardinal *);
#if defined(HAVE_DIVX4LINUX) || defined(HAVE_FFMPEG) || defined(HAVE_XVID)
void RecordMovieAction (Widget, XEvent *, String *, Cardinal *);
#endif

void set_volume (void);
void set_volume_alternate (void);


XtActionsRec actionTable[] = {
  {"CloseMain", CloseMainAction},
  {"SetRes", SetResAction},
  {"SetBg", SetBgAction},
  {"SetShadow", SetShadowAction},
  {"SetChannel", SetChannelAction},
  {"Tune", TuneAction},
  {"Scan", ScanAction},
  {"Channel", ChannelAction},
  {"Pointer", PointerAction},
  {"FullScreen", FullScreenAction},
  {"Options", OptionsAction},
  {"Channels", ChannelsAction},
  {"Editor", EditorAction},
  {"Remote", RemoteAction},
  {"Zap", ZapAction},
  {"Snap", SnapAction},
  {"Help", help_AC},
  {"Showtime", ShowtimeAction},
  {"Volume", VolumeAction},
  {"AleVT", AleVTAction},
  {"StayOnTop", StayOnTopAction},
  {"Decoration", DecorationAction},
#if defined(HAVE_DIVX4LINUX) || defined(HAVE_FFMPEG) || defined(HAVE_XVID)
  {"RecordMovie", RecordMovieAction},
  {"DivX", DivXAction},
#endif
  {"Deinterlace", DeinterlaceAction}
};

static struct STRTAB stereo[] = {
  {0, "auto"},
  {1, "mono"},
  {2, "stereo"},
  {-1, NULL}
};

static struct STRTAB cap_list[] = {
  {CAPTURE_OFF, "off"},
  {CAPTURE_OVERLAY, "overlay"},
  {CAPTURE_GRABDISPLAY, "grabdisplay"},
  {-1, NULL}
};

struct STRTAB deinterlace_list[] = {
  {DEINTERLACE_NONE,     "None"},
  {DEINTERLACE_BOB,      "Bob"},
  {DEINTERLACE_WEAVE,    "Weave"},
  {DEINTERLACE_GREEDY,   "Greedy"},
  {DEINTERLACE_ONEFIELD, "One Field"},
  {DEINTERLACE_LINEARBLEND, "Linear Blend"},
  {-1, NULL}
};

/*
struct STRTAB stayontop_list[] = {
  {STAYONTOP_ONBOTTOM, "Bottom"},
  {STAYONTOP_NORMAL, "Normal"},
  {STAYONTOP_ONTOP,  "Top"},
  {-1, NULL}
};
*/
struct STRTAB yes_no_list[] = {
  {WMHOOKS_YES, "Yes"},
  {WMHOOKS_NO,  "No"},
  {-1, NULL}
};

#if defined(HAVE_DIVX4LINUX) || defined(HAVE_FFMPEG) || defined(HAVE_XVID)
struct STRTAB record_list[] = {
  {RECORD_START, "Start"},
  {RECORD_STOP,  "Stop"},
  {RECORD_PARAM, "Parameters"},
  {-1, NULL}
};
#endif

static char *help_msg[] = {
"       -b depth\n"
"              force xawdecode into depth bits color depth.  Might\n"
"              be  needed for 24/32 bits. However the best perfor\n"
"              mances in grabdisplay mode are achieved with  a  16\n"
"              bits color depth.\n",

"       -f     startup in fullscreen mode.\n",

"       -nowd  startup with no window decoration.\n",

"       -m     startup with mouse pointer turned off.\n",

"       -n     don't read the config file ($HOME/.xawdecode/xawde\n"
"              coderc).\n",

"       -o filename\n"
"              set output filename for ppm  grabbing  (default  is\n"
"              snap000.ppm)\n",

"       -j filename\n"
"              set  output  filename for jpeg grabbing (default is\n"
"              snap000.jpeg)\n",

"       -v level\n"
"              Be verbose, level may be 0 (default), 1 or  2.   It\n"
"              exists just for debugging. If no level is provided,\n"
"              a level of 1 is assumed.\n",

"       -x     disable, the usage of XFree  extensions  (DGA,  Vid\n"
"              Mode).\n",

"       -d     disable the usage of XFree DGA extension.\n",

"       -c video device\n"
"              video4linux video device. For devfs enabled systems, default  is\n"
"              /dev/v4l/video  or /dev/v4l/video0, in that order. For non devfs\n"
"              systems,  default  is   /dev/video   or   /dev/video/video0   or\n"
"              /dev/video0, in that order.  Note that on /proc enabled systems,\n"
"              video device detection is automagic.\n",

"       -C vbi device\n"
"              video4linux vbi device. For devfs enabled  systems,  default  is\n"
"              /dev/v4l/vbi or /dev/v4l/vbi0, in that order. For non devfs sys-\n"
"              tems, default is /dev/vbi or  /dev/video/vbi  or  /dev/vbi0,  in\n"
"              that  order.   Note  that  on  /proc enabled systems, vbi device\n"
"              detection is automagic.\n"

"       -noxv | -no-xv\n"
"              disables  the  Xvideo support if it was com\n"
"              piled in.\n",

"       -xvport number\n"
"              set Xvideo Image port (defaults to the first\n"
"              usable  if  Xvideo  is available). A usuable\n"
"              one is one which does support YUY2 format.\n",

"       -hwscan\n"
"              print a list of available devices.\n",

"       -probe_memcpy\n"
"              force benchmarking of different possibilities\n"
"              for a fast memcpy function.\n",

"       -rec_fps fps\n"
"              set recording framerate (default=25.0)\n",

"       -rec_display 0|1\n"
"              set display mode during recording (default=1)\n",

"       -rec_width width\n"
"              set width of the recording video (default=384)\n",

"       -rec_videobr br\n"
"              set recording video bitrate to br kbit/s (default=800)\n",

"       -rec_mp3cbr br\n"
"              activate MP3 CBR and set bitrate to br kbit/s\n"
"              (default=activated, 128kbit/s)\n",

"       -rec_mp3vbr quality\n"
"              activate MP3 VBR and set compressing quality (0=best, 9=worst)\n"
"              (default=deactivated, quality=8)\n",

"       -rec_vcodec xvid|ffmpeg_mpeg4|ffmpeg_mpeg1|divx4linux\n"
"              set recording video codec\n",

"       -rec_maxgap\n"
"              set recording max gap between audio and video in seconds\n"
"              (default = 0.08 second)\n",

"       -e \"cmd_1; cmd_2; cmd_3;...cmd_n\" \n"
"              execute the commands at the beginning of execution\n",

"       -h     prints a brief usage message and exits.\n",
NULL};

char *cmd = NULL;

/*--- externs ------------------------------------------------------------*/
#if defined(HAVE_DIVX4LINUX) || defined(HAVE_FFMPEG) || defined (HAVE_XVID)
extern divx_t divx;
#endif
extern void setfps(double);
extern void init_socket(void);
extern void close_socket(void);
extern void do_command_mult(char *);

/*--- exit ----------------------------------------------------------------*/

Boolean
ExitWP (XtPointer client_data)
{
  /* exit if the application is idle,
   * i.e. all the DestroyCallback's are called.
   */
  exit (0);
}

void
ExitCB (Widget widget, XtPointer client_data, XtPointer calldata)
{

#if defined(HAVE_DIVX4LINUX) || defined(HAVE_FFMPEG) || defined(HAVE_XVID)
  if (is_divx_in_progress())
    divx_stop();
#endif

  if (plugin != NULL)
    plugin->close();

  if (hPlugin)
    dlclose(hPlugin);
  plugin = NULL;

#ifdef ALEVT_ENABLED
  
  if (alevt_in_use)
    stop_alevt();

#endif

  if (-1 != cur_sender)
    save_last_channel(cur_sender);

  /*
  if (idle_id)
    {
      XtRemoveWorkProc (idle_id);
      idle_id = 0;
    }
  */

  if (have_mixer)
    mixer_close ();
  grabbers[grabber]->grab_close ();

  video_overlay (NULL);
  video_close ();

  if (fs)
    XtCallActionProc (widget, "FullScreen", NULL, NULL, 0);

  XtAppAddWorkProc (app_context, ExitWP, NULL);
  XtDestroyWidget (app_shell);
  close_socket();
}

void
CloseMainAction (Widget widget, XEvent * event,
                 String * params, Cardinal * num_params)
{
  static Dimension x, y, w, h;
  char *argv[32];
  int argc = 0;

  if (event->type == ClientMessage)
    {
      if (event->xclient.data.l[0] == wm_protocols[1])
        {
          if (debug)
            fprintf (stderr, "Main: wm_save_yourself\n");

          argv[argc++] = progname;

          /* position */
          if (fs)
            {
              argv[argc++] = strdup ("-f");
            }
          else
            {
              XtVaGetValues (app_shell,
                             XtNx, &x, XtNy, &y, XtNwidth, &w, XtNheight, &h,
                             NULL);
              argv[argc++] = strdup ("-geometry");
              sprintf (argv[argc++] = malloc (32), "%dx%d+%d+%d", w, h, x, y);
            }
          argv[argc++] = strdup ("-c");
          argv[argc++] = strdup (device.video);

          /* grab filename */
          if (ppmfile)
            {
              argv[argc++] = strdup ("-o");
              argv[argc++] = malloc (256);
              argv[argc - 1][0] = '\0';
              if (ppmfile[0] != '/')
                {
                  getcwd (argv[argc - 1], 128);
                  strcat (argv[argc - 1], "/");
                }
              strcat (argv[argc - 1], ppmfile);
            }
          if (jpegfile)
            {
              argv[argc++] = strdup ("-j");
              argv[argc++] = malloc (256);
              argv[argc - 1][0] = '\0';
              if (jpegfile[0] != '/')
                {
                  getcwd (argv[argc - 1], 128);
                  strcat (argv[argc - 1], "/");
                }
              strcat (argv[argc - 1], jpegfile);
            }

          /* options */
          if (!xfree_ext)
            argv[argc++] = strdup ("-x");
          if (!pointer_on)
            argv[argc++] = strdup ("-m");
          if (bpp)
            {
              argv[argc++] = strdup ("-b");
              sprintf (argv[argc++] = malloc (8), "%d", bpp);
            }

          /* channel */
	  if (cur_sender!=-1)
          argv[argc++] = channels[cur_sender]->name;

          XSetCommand (XtDisplay (app_shell), XtWindow (app_shell), argv,
                       argc);
          return;
        }
    }
  ExitCB (widget, NULL, NULL);
}

void
sigint_handler(int sig)
{
  XKeyEvent kev;

  memset(&kev, 0, sizeof(XKeyEvent));
  kev.type = KeyPress;
  kev.send_event = True;
  kev.display = XtDisplay(tv);
  kev.window = XtWindow(tv);
  kev.keycode = XKeysymToKeycode(dpy, XK_Escape);
  printf("SIGINT received\n");
  /*
  if (idle_id)
    {
      XtRemoveWorkProc (idle_id);
      idle_id = 0;
    }
  */
  XSendEvent(XtDisplay(tv), XtWindow(tv), True, 0, (XEvent *)&kev );
  //ExitCB (tv, NULL, NULL);
}

static void
lirc_input(XtPointer data, int *fd, XtInputId *iproc)
{
    if (debug)
	fprintf(stderr,"lirc_input triggered\n");
    if (-1 == lirc_tv_havedata()) {
	fprintf(stderr,"lirc: connection lost\n");
	XtRemoveInput(*iproc);
	close(*fd);
    }
}

/*--- onscreen display (fullscreen and nxtvepg info) --------------------------*/

void
create_onscreen ()
{
  on_shell = XtVaCreateWidget ("onscreen", transientShellWidgetClass,
                               app_shell, XtNoverrideRedirect, True, NULL);
  on_label = XtVaCreateManagedWidget ("label", labelWidgetClass, on_shell,
                                      NULL);
}

void
popdown_onscreen (XtPointer client_data, XtIntervalId * id)
{
  XtPopdown (on_shell);
  on_timer = 0;
}

void
osd (int x_osd, int y_osd, char *osd_msg, int osd_time)
{
  /* if x_osd and y_osd > 0, the put osd window at x_osd and y_osd from top
   * left main window corner.
   * if x_osd < 0, center horizontaly osd window.
   * if y_osd < 0, y origin is the bottom of the main window...
   */
  static int first = 1;
  Dimension x, y;
  Dimension w, h;
  Dimension w_osd, h_osd;

  XtVaGetValues (app_shell, XtNx, &x, XtNy, &y, NULL);
  XtVaGetValues (app_shell, XtNwidth, &w, XtNheight, &h, NULL);

  XtVaSetValues (on_label, XtNlabel, osd_msg, NULL);
  XtVaGetValues (on_label, XtNwidth, &w_osd, XtNheight, &h_osd, NULL);

  if (x_osd > 0)
    x_osd += x;
  else
    x_osd = x + (w - w_osd)/2;

  if (y_osd > 0)
    y_osd += y;
  else
    y_osd = y + h - h_osd + y_osd;

  XtVaSetValues (on_shell, XtNx, x_osd, XtNy, y_osd, NULL);

  XtPopup (on_shell, XtGrabNone);

  if (on_timer)
    XtRemoveTimeOut (on_timer);

  if (osd_time > 0)
    on_timer = XtAppAddTimeOut
      (app_context, osd_time, popdown_onscreen, NULL);

  if (first)
    {
      first = 0;
      XDefineCursor (dpy, XtWindow (on_shell), no_ptr);
      XDefineCursor (dpy, XtWindow (on_label), no_ptr);
    }
}

void
display_onscreen ()
{

  if (on_skip)
    {
      on_skip = 0;
      return;
    }

  if (!fs && de)
    return;

  osd(30, 20, title, ONSCREEN_TIME);

}


/*--- tv -----------------------------------------------------------------*/

static Boolean
idle_grabdisplay1 (XtPointer data)
{
  static long count, lastsec;
  struct timeval tv;
  struct timezone tz;

  if (debug)
    {
      gettimeofday (&tv, &tz);
      if (tv.tv_sec != lastsec)
        {
          if (lastsec == tv.tv_sec - 1)
            {
              printf ("fps:%ld\n", count);
              fflush(stderr);
            }
          lastsec = tv.tv_sec;
          count = 0;
        }
      count++;
    }

  if ((NULL == grabbers[grabber]->grab_scr) ||
      (-1 == video_displayframe (grabbers[grabber]->grab_scr)))
    {
      idle_id = 0;
      usleep (300000);
      return TRUE;
    }
  return FALSE;
}

void
set_title ()
{
  if (-1 != cur_sender)
    {
      if (channels[cur_sender]->fine == 0)
        {
          if (cur_deinterlace == DEINTERLACE_NONE)
            sprintf (title, "%s", channels[cur_sender]->name);
          else
            sprintf (title, "%s (%s)", channels[cur_sender]->name, int_to_str(cur_deinterlace, deinterlace_list));
        }
      else
        {
          sprintf (title, "channel %s", tvtuner[cur_channel].name);
          if (cur_fine != 0)
            sprintf (title + strlen (title), " (%d)", cur_fine);
          sprintf (title + strlen (title), " (%s/%s)",
                   grabbers[grabber]->norms[cur_norm].str,
                   chan_names[chan_tab].str);
        }
    }
  else
    sprintf(title, "No sender");

  XtVaSetValues (app_shell, XtNtitle, title, NULL);
  display_onscreen ();

  if (title_timer)
    {
      XtRemoveTimeOut (title_timer);
      title_timer = 0;
    }
}

void
set_property (int freq, char *channel, char *name)
{
  int len;
  char line[80];

  len = sprintf (line, "%.3f", (float) freq / 16) + 1;
  len += sprintf (line + len, "%s", channel) + 1;
  if (NULL != name)
    len += sprintf (line + len, "%s", name) + 1;
  XChangeProperty (dpy, XtWindow (app_shell),
                   xawtv_station, XA_STRING, 8, PropModeReplace, line, len);
}

void
set_title_timeout (XtPointer client_data, XtIntervalId * id)
{
  on_skip = 1;
  set_title ();
}

void
set_timer_title ()
{
  XtVaSetValues (app_shell, XtNtitle, title, NULL);
  display_onscreen ();
  if (title_timer)
    XtRemoveTimeOut (title_timer);
  title_timer = XtAppAddTimeOut
    (app_context, TITLE_TIME, set_title_timeout, NULL);
}


void
change_audio (int mode)
{
  if (grabbers[grabber]->grab_audio)
    grabbers[grabber]->grab_audio (-1, -1, &mode);
  sprintf (title, "%-" LABEL_WIDTH "s: %s", "Audio", stereo[mode].str);
  if (c_audio)
    XtVaSetValues (c_audio, XtNlabel, title, NULL);
  set_title ();
  sprintf (title + strlen (title), " (%s)", stereo[mode].str);
  XtVaSetValues (app_shell, XtNtitle, title, NULL);
}


void
watch_audio (XtPointer data, XtIntervalId * id)
{
  on_skip = 1;
  change_audio (0);
  audio_timer = 0;
}

void
set_norm (int j)
{
  sprintf (title, "%-" LABEL_WIDTH "s: %s", "TV Norm",
           grabbers[grabber]->norms[j].str);
  if (c_norm)
    XtVaSetValues (c_norm, XtNlabel, title, NULL);
  cur_norm = j;
  grabbers[grabber]->grab_input (-1, cur_norm);
  video_setmax (maxwidth[cur_norm], maxheight[cur_norm]);
}

void
set_source (int j)
{
  sprintf (title, "%-" LABEL_WIDTH "s: %s", "Video Source",
           grabbers[grabber]->inputs[j].str);
  if (c_input)
    XtVaSetValues (c_input, XtNlabel, title, NULL);
  cur_input = j;
  grabbers[grabber]->grab_input (cur_input, -1);
}

void
set_freqtab (int j)
{
  sprintf (title, "%-" LABEL_WIDTH "s: %s", "Frequency table",
           chan_names[j].str);
  if (c_freq)
    XtVaSetValues (c_freq, XtNlabel, title, NULL);
  chan_tab = j;
}

void
set_capture (int capture)
{
/*  static int niced = 0; */

  if (cur_capture == capture)
    {
      if (cur_capture == CAPTURE_GRABDISPLAY && !idle_id)
        idle_id = XtAppAddWorkProc (app_context, idle_grabdisplay, NULL);
      return;
    }


  /* first turn off... */
  switch (cur_capture)
    {
    case CAPTURE_GRABDISPLAY:
      if (idle_id)
        XtRemoveWorkProc (idle_id);
      idle_id = 0;
      XClearArea (XtDisplay (tv), XtWindow (tv), 0, 0, 0, 0, True);
      break;

    case CAPTURE_OVERLAY:
      video_overlay (NULL);
      break;
    }

  cur_capture = capture;

  /* ... then turn on */
  switch (cur_capture)
    {
    case CAPTURE_OFF:
      sprintf (title, "%-" LABEL_WIDTH "s: %s", "Capture", "off");
      break;

    case CAPTURE_GRABDISPLAY:
      sprintf (title, "%-" LABEL_WIDTH "s: %s", "Capture", "grabdisplay");
      /*
      if (!niced)
        nice (niced = 10);
       */
      idle_id = XtAppAddWorkProc (app_context, idle_grabdisplay, NULL);
      break;

    case CAPTURE_OVERLAY:
      sprintf (title, "%-" LABEL_WIDTH "s: %s", "Capture", "overlay");
      video_overlay (grabbers[grabber]->grab_overlay);
      break;
    }

  video_new_size(ADAPT_SIZE);

  if (cur_sender != -1)
    channels[cur_sender]->capture = cur_capture;
    
  if (c_cap)
    XtVaSetValues (c_cap, XtNlabel, title, NULL);
}

/* the RightWay[tm] to set float resources (copyed from Xaw specs) */
void
set_float (Widget widget, char *name, float value)
{
  Arg args[1];

  if (sizeof (float) > sizeof (XtArgVal))
    {
      /*
       * If a float is larger than an XtArgVal then pass this 
       * resource value by reference.
       */
      XtSetArg (args[0], name, &value);
    }
  else
    {
      /*
       * Convince C not to perform an automatic conversion, which
       * would truncate 0.5 to 0. 
       */
      XtArgVal *l_top = (XtArgVal *) & value;
      XtSetArg (args[0], name, *l_top);
    }
  XtSetValues (widget, args, 1);
}

void
set_picparams (int color, int bright, int hue, int contrast)
{
  if (color != -1)
    {
      cur_color = color;
      if (s_color)
        set_float (s_color, XtNtopOfThumb, (float) cur_color / 65536);
      if (cur_sender != -1)
        channels[cur_sender]->color = cur_color;
    }
  if (bright != -1)
    {
      cur_bright = bright;
      if (s_bright)
        set_float (s_bright, XtNtopOfThumb, (float) cur_bright / 65536);
      if (cur_sender != -1)
        channels[cur_sender]->bright = cur_bright;
    }
  if (hue != -1)
    {
      cur_hue = hue;
      if (s_hue)
        set_float (s_hue, XtNtopOfThumb, (float) cur_hue / 65536);
      if (cur_sender != -1)
        channels[cur_sender]->hue = cur_hue;
    }
  if (contrast != -1)
    {
      cur_contrast = contrast;
      if (s_contrast)
        set_float (s_contrast, XtNtopOfThumb, (float) cur_contrast / 65536);
      if (cur_sender != -1)
        channels[cur_sender]->contrast = cur_contrast;
    }
  grabbers[grabber]->grab_picture (cur_color, cur_bright, cur_hue,
                                   cur_contrast);
}

void
set_deinterlace(int j)
{
  int len;
  int i;

  cur_deinterlace = j;
  if (cur_sender != -1)
    channels[cur_sender]->deinterlace = cur_deinterlace;

  sprintf (title, "%-" LABEL_WIDTH "s: %s", "Deinterlace",
           int_to_str(j, deinterlace_list));

  len = strlen(title);

  for (i=len; i<=32-6; i++) // 6 = strlen("CTRL+D")
    title[i] = ' ';
  title[i] = 0;
  strcat(title, "CTRL+D");

  if (c_deinterlace)
    XtVaSetValues (c_deinterlace, XtNlabel, title, NULL);

  title[len] = 0;
}

int
set_stayontop(int j)
{
  static int top = 0;
  char *fmt = NULL;

  if (!wm_stay_on_top)
    return 0;

  if (j == -1)
    top = 1 - top;
  else
    top = j;

  switch(top)
    {
    case WMHOOKS_YES:
      fmt = "%-" LABEL_WIDTH "s:     (%s)%6s";
      break;

    case WMHOOKS_NO:
      fmt = "%-" LABEL_WIDTH "s:     (%s)%7s";
      break;
    }

  // if Yes/No, just transmit top value
  // if OnBottom/Normal/OnTop, transmit (top-1)
  wm_stay_on_top(dpy, XtWindow(app_shell), top);

  sprintf (title, fmt, "Stay on Top",
           int_to_str(top, yes_no_list), "T");

  if (c_stayontop)
    XtVaSetValues (c_stayontop, XtNlabel, title, NULL);

  sprintf (title, "%-" LABEL_WIDTH "s: %s", "Stay on Top",
           int_to_str(top, yes_no_list));

  return 1;
}

int
set_decoration(int j)
{
  static int decoration = WMHOOKS_YES;
  char *fmt = NULL;

  if (j == -1)
    decoration = 1 - decoration;
  else
    decoration = j;

  wm_decoration(app_shell, decoration);

  switch(decoration)
    {
    case WMHOOKS_YES:
      fmt = "%-" LABEL_WIDTH "s:     (%s)%5s";
      break;

    case WMHOOKS_NO:
      fmt = "%-" LABEL_WIDTH "s:     (%s)%6s";
      break;
    }
  sprintf (title, fmt, "Window Decoration",
           int_to_str(decoration, yes_no_list), "B");

  if (c_decoration)
    XtVaSetValues (c_decoration, XtNlabel, title, NULL);

  title[0] = 0;

  de = decoration ;
  return 1;
}

#if defined(HAVE_DIVX4LINUX) || defined(HAVE_FFMPEG) || defined(HAVE_XVID)
void
record_movie(int j)
{
  static int record = RECORD_STOP;
  char *fmt = NULL;
  Dimension w,h;
  //int w,h;
  char *filename;
  int prev_record;

  prev_record = record;

  if (j == -1)
    {
      /* j = -1 means toggle state, but between RECORD_START
       * and RECORD_STOP only
       */
      record = (record+1)%3;
      if (record == RECORD_PARAM)
        record = (record+1)%3;
    }
  else
    {
      /* If record is in progress, do not allow to 
       * raise RECORD_PARAM
       */
      if ((record == RECORD_START)&&(j == RECORD_PARAM))
        return;
      else
        record = j;
    }

  if (record == prev_record)
    return;

  switch(record)
    {
    case RECORD_START:
      XtVaGetValues (tv, XtNwidth, &w, XtNheight, &h, NULL);
      //video_get_size(&w, &h);
      filename = snap_filename ("movie",(channels) ? channels[cur_sender]->name:
       				"unknown","avi");
      divx_init(filename, divx_pixmap_format, w, h);
      fmt = "%-" LABEL_WIDTH "s:     (On)      R";
      break;

    case RECORD_STOP:
      divx_stop();
      fmt = "%-" LABEL_WIDTH "s:     (Off)     R";
      break;

    case RECORD_PARAM:
      record = prev_record;
      DivXAction(NULL, NULL, NULL, NULL);
      return; // return now: do not modify title
      break;
    }

  sprintf (title, fmt, "Record movie");

  if (c_record)
    XtVaSetValues (c_record, XtNlabel, title, NULL);
}
#endif // HAVE_DIVX4LINUX || HAVE_FFMPEG || HAVE_XVID

/*
void
pixit (void)
{
  Pixmap pix;
  char *data;

  if (0 == pix_width || 0 == pix_height)
    return;

  if (cur_sender != -1 && grabbers[grabber]->grab_scr)
    {
      strcpy (title, channels[cur_sender]->name);
      data = malloc (pix_width * pix_height * 4);
      
      if (NULL !=
          grabbers[grabber]->grab_scr (data, pix_width, pix_height, 1, pix_width)
          && 0 != (pix = x11_create_pixmap (channels[cur_sender]->button, data,
                                            pix_width, pix_height, title)))
        {
          if (channels[cur_sender]->pixmap)
            XFreePixmap (dpy, channels[cur_sender]->pixmap);
          channels[cur_sender]->pixmap = pix;
          XtVaSetValues (channels[cur_sender]->button,
                         XtNbackgroundPixmap, pix,
                         XtNlabel, "",
                         XtNwidth, pix_width, XtNheight, pix_height, NULL);
        }
      free (data);
    }
}
*/

void
pixit (void)
{
  Pixmap pix;
  char *data;

  if (0 == pix_width || 0 == pix_height)
    return;

  if (cur_sender != -1 && grabbers[grabber]->grab_one)
    {
      strcpy (title, channels[cur_sender]->name);

      data = grabbers[grabber]->grab_one (x11_native_format, pix_width, pix_height);
      if (data != NULL)
        {
          pix = x11_create_pixmap (channels[cur_sender]->button, data,
                                   pix_width, pix_height, title);
          if (pix != 0)
            {
              if (channels[cur_sender]->pixmap)
                XFreePixmap (dpy, channels[cur_sender]->pixmap);
              channels[cur_sender]->pixmap = pix;
              XtVaSetValues (channels[cur_sender]->button,
                             XtNbackgroundPixmap, pix,
                             XtNlabel, "",
                             XtNwidth, pix_width, XtNheight, pix_height, NULL);
            }
        }
    }
}

void
set_channel (struct CHANNEL *channel)
{
  /* image parameters */
  set_picparams (channel->color, channel->bright,
                 channel->hue, channel->contrast);
  set_capture (channel->capture);

  if (plugin != NULL)
    plugin->set_channel(channel);

  /* input source */
  if (cur_input != channel->source)
    set_source (channel->source);
  if (cur_norm != channel->norm)
    set_norm (channel->norm);

  /* station */
  cur_channel = channel->channel;
  cur_fine = channel->fine;
  grabbers[grabber]->grab_tune (channel->freq);
  editor_station_switched ();
  //set_title ();
  set_property (channel->freq, channel->cname, channel->name);

  /* deinterlace */
  if (cur_deinterlace != channel->deinterlace)
    set_deinterlace (channel->deinterlace);

  set_title ();

  if (zap_timer)
    {
      XtRemoveTimeOut (zap_timer);
      zap_timer = 0;
    }
  if (scan_timer)
    {
      XtRemoveTimeOut (scan_timer);
      scan_timer = 0;
    }
  if (audio_timer)
    {
      XtRemoveTimeOut (audio_timer);
      audio_timer = 0;
    }
  audio_timer = XtAppAddTimeOut (app_context, 10000, watch_audio, NULL);

}

void
change_int (char *name, char *par, int *val)
{
  switch (par[0])
    {
    case '+':
    case '-':
      *val += atoi (par);
      break;
    default:
      *val = atoi (par);
      break;
    }
  if (*val < 0)
    *val = 0;
  if (*val > 65535)
    *val = 65535;
  sprintf (title, "%s: %d%%", name, *val * 100 / 65535);
}

#if defined(HAVE_DIVX4LINUX) || defined(HAVE_FFMPEG) || defined(HAVE_XVID)
void
RecordMovieAction (Widget widget, XEvent * event,
              String * params, Cardinal * num_params)
{
  record_movie(-1);
}
#endif

void
DeinterlaceAction (Widget widget, XEvent * event,
              String * params, Cardinal * num_params)
{
  set_deinterlace( (cur_deinterlace + 1) % NB_DEINTERLACE );
  set_timer_title ();
}

void
StayOnTopAction (Widget widget, XEvent * event,
              String * params, Cardinal * num_params)
{
  if (set_stayontop(-1))
    set_timer_title ();
}

void
DecorationAction (Widget widget, XEvent * event,
              String * params, Cardinal * num_params)
{
   if (on_timer)
   {
     XtPopdown (on_shell);
     XtRemoveTimeOut (on_timer);
     on_timer = 0;
   }
  set_decoration(-1);
}

void
VolumeAction (Widget widget, XEvent * event,
              String * params, Cardinal * num_params)
{
  char *msg = (char *)NULL;

  if (*num_params < 1)
    return;

  if (0 == strcasecmp (params[0], "mute"))
    cur_mute = !cur_mute;
  else if (0 == strcasecmp (params[0], "inc"))
    cur_volume += 512;
  else if (0 == strcasecmp (params[0], "dec"))
    cur_volume -= 512;
  else
    cur_volume += (atoi (params[0]) * 65535)/100;

  if (cur_volume < 0)
    cur_volume = 0;
  if (cur_volume > 65535)
    cur_volume = 65535;

  if (plugin != NULL)
    msg = plugin->use_alternate();

  if (msg != (char *)NULL)
    set_volume_alternate ();
  else
    set_volume ();

  if (cur_mute)
    sprintf (title, "Volume (%s): muted", have_mixer ? "mixer" : "v4l");
  else
    sprintf (title, "Volume (%s): %d%%", have_mixer ? "mixer" : "v4l",
             cur_volume * 100 / 65535);

  if (msg)
    sprintf (title, "%s %s", title, msg);

  set_timer_title ();
}

void
SetBgAction (Widget widget, XEvent * event,
             String * params, Cardinal * num_params)
{
  XColor have, exact;

  if (*num_params != 1)
    fprintf (stderr, "SetBg: usage: SetRes(color)\n");
  XAllocNamedColor (dpy, DefaultColormapOfScreen (XtScreen (widget)),
                    params[0], &have, &exact);
  XtVaSetValues (widget, XtNbackground, have.pixel, NULL);
}

void
SetShadowAction (Widget widget, XEvent * event,
                 String * params, Cardinal * num_params)
{
  Dimension n;

  if (*num_params != 1)
    fprintf (stderr, "SetShadow: usage: SetShadow(int)\n");
  n = atoi (params[0]);
  XtVaSetValues (widget, "shadowWidth", n, NULL);
}

void
ShowtimeAction (Widget widget, XEvent * event,
              String * params, Cardinal * num_params)
{
    struct tm *times;
    time_t timet;

    timet = time(NULL);
    times = localtime(&timet);
    strftime(title, 6, "%k:%M", times);
    set_timer_title ();
}

void
SetResAction (Widget widget, XEvent * event,
              String * params, Cardinal * num_params)
{
  if (*num_params != 2)
    fprintf (stderr, "SetRes: usage: SetRes(resource,value)\n");

  if (0 == strcmp ("color", params[0]))
    {
      change_int (params[0], params[1], &cur_color);
      set_picparams (cur_color, -1, -1, -1);
    }
  else if (0 == strcmp ("contrast", params[0]))
    {
      change_int (params[0], params[1], &cur_contrast);
      set_picparams (-1, -1, -1, cur_contrast);
    }
  else if (0 == strcmp ("bright", params[0]))
    {
      change_int (params[0], params[1], &cur_bright);
      set_picparams (-1, cur_bright, -1, -1);
    }
  else if (0 == strcmp ("hue", params[0]))
    {
      change_int (params[0], params[1], &cur_hue);
      set_picparams (-1, -1, cur_hue, -1);
    }
  else if (0 == strcmp (params[0], "capture"))
    {
      set_capture ((cur_capture + 1) % 3);
    }
  else if (0 == strcmp ("audio", params[0]))
    {
      change_audio (atoi (params[1]));
    }
  else
    return;

  set_timer_title ();
  return;
}

void
set_volume ()
{
  int vol;

  if (have_mixer)
    {
      /* sound card */
      vol = cur_volume * 100 / 65536;
      mixer_set_volume (vol);
      cur_mute ? mixer_mute () : mixer_unmute ();
    }
  else
    {
      /* v4l */
      if (grabbers[grabber]->grab_audio)
        grabbers[grabber]->grab_audio (cur_mute, cur_volume, NULL);
    }

  if (s_volume)
    set_float (s_volume, XtNtopOfThumb, (float) cur_volume / 65536);
}

void
set_volume_alternate ()
{
  int vol;

  if (have_mixer)
    {
      /* sound card */
      vol = cur_volume * 100 / 65536;

      if (mixer_set_device (1) != -1)
        {
          mixer_set_volume (vol);
          cur_mute ? mixer_mute () : mixer_unmute ();
        }

      if (mixer_set_device (2) != -1)
        {
          mixer_set_volume (vol);
          cur_mute ? mixer_mute () : mixer_unmute ();
        }

      mixer_set_device (0);
    }

  if (s_volume)
    set_float (s_volume, XtNtopOfThumb, (float) cur_volume / 65536);
}


void
SetChannelAction (Widget widget, XEvent * event,
                  String * params, Cardinal * num_params)
{
  int i;

  if (*num_params > 1)
    return;

#if defined(HAVE_DIVX4LINUX) || defined(HAVE_FFMPEG) || defined(HAVE_XVID)
  if (is_divx_in_progress())
    return;
#endif

  if (count && 0 == strcmp (params[0], "next"))
    {
      i = (cur_sender + 1) % count;
    }
  else if (count && 0 == strcmp (params[0], "prev"))
    {
      i = (cur_sender + count - 1) % count;
    }
  else
    {
      /* search the configured channels first... */
      for (i = 0; i < count; i++)
        if (0 == strcasecmp (channels[i]->name, params[0]))
          break;
      /* ... if it failes, take the argument as index */
      if (i == count)
        i = atoi (params[0]);
    }
  if (i >= 0 && i < count)
    {
      if (!cur_mute) mixer_mute();
      pixit ();
      cur_sender = i;
      set_channel (channels[i]);
      usleep(MUTE_TIME * 1000);
      if (!cur_mute) mixer_unmute();
    }
}

void
RemoteAction (Widget widget, XEvent * event,
              String * params, Cardinal * num_params)
{
  Atom type;
  int format, argc, i;
  char *argv[32];
  unsigned long nitems, bytesafter;
  unsigned char *args = NULL;

  if (event->type == PropertyNotify)
    {
#if 0
      fprintf (stderr, "PropertyNotify %s\n",
               XGetAtomName (dpy, event->xproperty.atom));
#endif
      if (event->xproperty.atom == xawtv_remote &&
          Success == XGetWindowProperty (dpy,
                                         event->xproperty.window,
                                         event->xproperty.atom,
                                         0, (65536 / sizeof (long)),
                                         True, XA_STRING,
                                         &type, &format, &nitems, &bytesafter,
                                         &args) && nitems != 0)
        {
          if (debug)
            fprintf (stderr, "remote control: ");

          for (i = 0, argc = 0; i < nitems; i += strlen (args + i) + 1)
            {
              if (debug)
                fprintf (stderr, "'%s' ", args + i);

              argv[argc++] = args + i;
            }

          if (debug)
            fprintf (stderr, "\n");

          if (0 == strcasecmp (argv[0], "setstation") && argc > 1)
            {
              XtCallActionProc (tv, "SetChannel", NULL, argv + 1, 1);
            }
          else if (0 == strcasecmp (argv[0], "setchannel") && argc > 1)
            {
              XtCallActionProc (tv, "Tune", NULL, argv + 1, 1);
            }
          else if (0 == strcasecmp (argv[0], "volume") && argc > 1)
            {
              XtCallActionProc (tv, "Volume", NULL, argv + 1, 1);
            }
          else if (0 == strcasecmp (argv[0], "message") && argc > 1)
            {
              strcpy (title, argv[1]);
              set_timer_title ();
            }
          else if (0 == strcasecmp (argv[0], "vtx"))
            {
              if (argc == 1)
                {
                  // single vtx command with no args -> clear osd
                  popdown_onscreen (NULL, NULL);
                }
              else if (argc > 1)
                {
                  // n line vtx command
                  char *s;
                  int size;

                  size=1;
                  for(i=1; i<argc; i++)
                    size += strlen(argv[i])+1;
                  s = malloc(size);
                  *s=0;
                  for(i=1; i<argc-1; i++)
                    sprintf(s, "%s%s\n", s, argv[i]);
                  sprintf(s, "%s%s", s, argv[argc-1]);
                  osd(-1, -1, s, -1);

                  free(s);
                }
            }

          XFree (args);
        }
    }
}

void
scan_timeout (XtPointer client_data, XtIntervalId * id)
{
  static String argv[] = { "next", NULL };

  scan_timer = 0;

  /* check */
  if (!grabbers[grabber]->grab_tuned)
    return;
  if (grabbers[grabber]->grab_tuned ())
    return;

  XtCallActionProc (tv, "Tune", NULL, argv, 1);
  scan_timer = XtAppAddTimeOut (app_context, SCAN_TIME, scan_timeout, NULL);
}

void
ScanAction (Widget widget, XEvent * event,
            String * params, Cardinal * num_params)
{
  static String argv[] = { "next", NULL };

  pixit ();
  XtCallActionProc (tv, "Tune", NULL, argv, 1);
  scan_timer = XtAppAddTimeOut (app_context, SCAN_TIME, scan_timeout, NULL);
}

void
TuneAction (Widget widget, XEvent * event,
            String * params, Cardinal * num_params)
{
  int c, freq;

  if (*num_params < 1)
    return;

#if defined(HAVE_DIVX4LINUX) || defined(HAVE_FFMPEG) || defined(HAVE_XVID)
  if (is_divx_in_progress())
    return;
#endif

  if (0 == strcasecmp (params[0], "next"))
    {
      do
        {
          cur_channel = (cur_channel + 1) % CHAN_ENTRIES;
        }
      while (!tvtuner[cur_channel].freq[chan_tab]);
      cur_fine = defaults.fine;
      cur_sender = -1;
    }
  else if (0 == strcasecmp (params[0], "prev"))
    {
      do
        {
          cur_channel = (cur_channel + CHAN_ENTRIES - 1) % CHAN_ENTRIES;
        }
      while (!tvtuner[cur_channel].freq[chan_tab]);
      cur_fine = defaults.fine;
      cur_sender = -1;
    }
  else if (0 == strcasecmp (params[0], "fine_up"))
    {
      cur_fine++;
      if (cur_sender != -1)
        channels[cur_sender]->fine = cur_fine;
    }
  else if (0 == strcasecmp (params[0], "fine_down"))
    {
      cur_fine--;
      if (cur_sender != -1)
        channels[cur_sender]->fine = cur_fine;
    }
  else
    {
      if (-1 != (c = lookup_channel (params[0])))
        {
          cur_channel = c;
          cur_fine = defaults.fine;
        }
      cur_sender = -1;
    }

  pixit ();

  // Why the hell were those 2 lines here ?
  //cur_sender = -1;
  //set_capture (defaults.capture /* CAPTURE_OVERLAY */ );

  freq = get_freq (cur_channel) + cur_fine;

  if (cur_sender != -1)
    channels[cur_sender]->freq = freq;

  grabbers[grabber]->grab_tune (freq);
  editor_station_switched ();
  set_title ();
  set_property (freq, tvtuner[cur_channel].name, NULL);

  if (zap_timer)
    {
      XtRemoveTimeOut (zap_timer);
      zap_timer = 0;
    }
  if (scan_timer)
    {
      XtRemoveTimeOut (scan_timer);
      scan_timer = 0;
    }
  if (audio_timer)
    {
      XtRemoveTimeOut (audio_timer);
      audio_timer = 0;
    }
  audio_timer = XtAppAddTimeOut (app_context, 10000, watch_audio, NULL);
}

void
ChannelAction (Widget widget, XEvent * event,
               String * params, Cardinal * num_params)
{
  int i;

  if (0 == count)
    return;
  i = popup_menu (widget, "Stations", cmenu);

  if (i != -1)
    {
      if (!cur_mute) mixer_mute();
      pixit ();
      cur_sender = i - 1;
      set_channel (channels[cur_sender]);
      usleep(MUTE_TIME * 1000);
      if (!cur_mute) mixer_unmute();
    }
}

void
PointerAction (Widget widget, XEvent * event,
               String * params, Cardinal * num_params)
{
  pointer_on = !pointer_on;
  XDefineCursor (dpy, XtWindow (tv), pointer_on ? left_ptr : no_ptr);
}

Boolean
MyResize (XtPointer client_data)
{
  video_new_size (ADAPT_SIZE);

  return TRUE;
}

#ifdef HAVE_LIBXXF86VM
static void
vidmode_timer (XtPointer clientData, XtIntervalId * id)
{
  set_capture (CAPTURE_OVERLAY);
}

static void
set_vidmode (int nr)
{
  if (CAPTURE_OVERLAY == cur_capture)
    video_overlay (NULL);
  usleep (VIDMODE_DELAY * 1000);
  if (debug)
    fprintf (stderr, "switching video mode to %dx%d now\n",
             vm_modelines[nr]->hdisplay, vm_modelines[nr]->vdisplay);
  XF86VidModeSwitchToMode (dpy, XDefaultScreen (dpy), vm_modelines[nr]);

  if (CAPTURE_OVERLAY == cur_capture)
    {
      cur_capture = 0;
      XtAppAddTimeOut (app_context, VIDMODE_DELAY, vidmode_timer, NULL);
    }
}
#endif

void
FullScreenAction (Widget widget, XEvent * event,
                  String * params, Cardinal * num_params)
{
  static Dimension x, y, w, h;
  static int timeout, interval, prefer_blanking, allow_exposures, rpx, rpy,
    mouse;
#ifdef HAVE_LIBXXF86VM
  static int vm_switched;
#endif
#ifdef HAVE_LIBXDPMS
  static BOOL dpms_on;
  CARD16 dpms_state;
  int dpms_dummy;
#endif

  Window root, child;
  int wpx, wpy, mask;

#if defined(HAVE_DIVX4LINUX) || defined(HAVE_FFMPEG) || defined(HAVE_XVID)
  if (is_divx_in_progress())
    return;
#endif

  if (fs)
    {
      if (wm_fullscreen != NULL)
        {
          wm_fullscreen(dpy, XtWindow(app_shell), 0);
        }
      else
        {

#ifdef HAVE_LIBXXF86VM
          if (have_vm && vm_switched)
            {
              set_vidmode (0);
              vm_switched = 0;
            }
#endif

          if (on_timer)
            {
              XtPopdown (on_shell);
              XtRemoveTimeOut (on_timer);
              on_timer = 0;
            }

          XtVaSetValues (app_shell,
                         XtNwidthInc, WIDTH_INC,
                         XtNheightInc, HEIGHT_INC,
                         XtNx, x + fs_xoff,
                         XtNy, y + fs_yoff, XtNwidth, w, XtNheight, h, NULL);

          XSetScreenSaver (dpy, timeout, interval, prefer_blanking,
                           allow_exposures);
#ifdef HAVE_LIBXDPMS
          if ((DPMSQueryExtension (dpy, &dpms_dummy, &dpms_dummy)) &&
              (DPMSCapable (dpy)) && (dpms_on))
            {
              DPMSEnable (dpy);
            }
#endif
        }
      XWarpPointer (dpy, None, RootWindowOfScreen (XtScreen (tv)),
                    0, 0, 0, 0, rpx, rpy);

      set_stayontop(WMHOOKS_NO);

      fs = 0;
    }
  else
    {
      int vp_x, vp_y, vp_width, vp_height;

      if (wm_fullscreen != NULL)
        {
          wm_fullscreen(dpy, XtWindow(app_shell), 1);
        }
      else
        {
          vp_x = 0;
          vp_y = 0;
          vp_width = swidth;
          vp_height = sheight;
          XQueryPointer (dpy, RootWindowOfScreen (XtScreen (tv)),
                         &root, &child, &rpx, &rpy, &wpx, &wpy, &mask);

#ifdef HAVE_LIBXXF86VM
          if (have_vm)
            {
              int i;
              XF86VidModeGetAllModeLines (dpy, XDefaultScreen (dpy),
                                          &vm_count, &vm_modelines);
              for (i = 0; i < vm_count; i++)
                if (fs_width == vm_modelines[i]->hdisplay &&
                    fs_height == vm_modelines[i]->vdisplay)
                  break;
              if (i != 0 && i != vm_count)
                {
                  set_vidmode (i);
                  vm_switched = 1;
                  vp_width = vm_modelines[i]->hdisplay;
                  vp_height = vm_modelines[i]->vdisplay;
                }
              else
                {
                  vm_switched = 0;
                  vp_width = vm_modelines[0]->hdisplay;
                  vp_height = vm_modelines[0]->vdisplay;
                }
#if 0
              XF86VidModeGetViewPort (dpy, XDefaultScreen (dpy), &vp_x, &vp_y);
#else
              XWarpPointer (dpy, None, RootWindowOfScreen (XtScreen (tv)),
                            0, 0, 0, 0, vp_width / 2, vp_height / 2);
              XF86VidModeSetViewPort (dpy, XDefaultScreen (dpy), 0, 0);
#endif
              if (debug)
                fprintf (stderr, "viewport: %dx%d+%d+%d\n",
                         vp_width, vp_height, vp_x, vp_y);
            }
#endif
          XtVaGetValues (app_shell,
                         XtNx, &x, XtNy, &y, XtNwidth, &w, XtNheight, &h, NULL);

          XtVaSetValues (app_shell, XtNwidthInc, 1, XtNheightInc, 1, NULL);
          XtVaSetValues (app_shell,
                         XtNx, (vp_x & 0xfffc) + fs_xoff,
                         XtNy, vp_y + fs_yoff,
                         XtNwidth, vp_width, XtNheight, vp_height, NULL);

          XRaiseWindow (dpy, XtWindow (app_shell));

          XGetScreenSaver (dpy, &timeout, &interval,
                           &prefer_blanking, &allow_exposures);
          XSetScreenSaver (dpy, 0, 0, DefaultBlanking, DefaultExposures);

#ifdef HAVE_LIBXDPMS
          if ((DPMSQueryExtension (dpy, &dpms_dummy, &dpms_dummy)) &&
              (DPMSCapable (dpy)))
            {
              DPMSInfo (dpy, &dpms_state, &dpms_on);
              DPMSDisable (dpy);
            }
#endif
        }
      XWarpPointer (dpy, None, XtWindow (tv), 0, 0, 0, 0, 30, 15);
      mouse = pointer_on;

      set_stayontop(WMHOOKS_YES);

      fs = 1;
    }
  if (mouse)
    XtCallActionProc (tv, "Pointer", NULL, NULL, 0);
  XtAppAddWorkProc (app_context, MyResize, NULL);
}

void
ChannelsAction (Widget widget, XEvent * event,
                String * params, Cardinal * num_params)
{
  static int mapped = 0, first = 1;
  Dimension height;

  if (!count)
    return;

  if (event && event->type == ClientMessage)
    {
      if (event->xclient.data.l[0] == wm_protocols[1])
        {
          if (debug)
            fprintf (stderr, "Channels: wm_save_yourself\n");
          XSetCommand (XtDisplay (chan_shell), XtWindow (chan_shell), NULL,
                       0);
          return;
        }
    }

  if (mapped)
    {
      XtPopdown (chan_shell);
      mapped = 0;
    }
  else
    {
      XtPopup (chan_shell, XtGrabNone);
      mapped = 1;
      if (first)
        {
          first = 0;
          XSetWMProtocols (XtDisplay (chan_shell), XtWindow (chan_shell),
                           wm_protocols, 2);
          XtVaGetValues (chan_shell, XtNheight, &height, NULL);
          if (height > sheight - 100)
            XtVaSetValues (chan_shell, XtNheight, sheight - 100, NULL);
        }
    }
}

void
button_cb (Widget widget, XtPointer clientdata, XtPointer call_data)
{
  struct CHANNEL *channel = clientdata;
  int i;

#if defined(HAVE_DIVX4LINUX) || defined(HAVE_FFMPEG) || defined(HAVE_XVID)
  if (is_divx_in_progress())
    return;
#endif

  pixit ();
  for (i = 0; i < count; i++)
    if (channels[i] == channel)
      break;
  cur_sender = i;
  set_channel (channels[i]);
}

void
create_chanwin ()
{
  chan_shell = XtVaAppCreateShell ("Channels", "Xawdecode",
                                   topLevelShellWidgetClass,
                                   dpy, XtNclientLeader, app_shell, NULL);
  XtOverrideTranslations (chan_shell, XtParseTranslationTable
                          ("<Message>WM_PROTOCOLS: Channels()"));
  chan_viewport = XtVaCreateManagedWidget ("viewport",
                                           viewportWidgetClass, chan_shell,
                                           XtNallowHoriz, False,
                                           XtNallowVert, True, NULL);
  chan_box = XtVaCreateManagedWidget ("channelbox",
                                      boxWidgetClass, chan_viewport,
                                      XtNsensitive, True, NULL);
}

void
channel_menu ()
{
  int i, max, len;
  char str[100];

  /* XXX memory leak */
  cmenu = malloc ((count + 1) * sizeof (struct STRTAB));
  memset (cmenu, 0, (count + 1) * sizeof (struct STRTAB));
  for (i = 0, max = 0; i < count; i++)
    {
      len = strlen (channels[i]->name);
      if (max < len)
        max = len;
    }
  for (i = 0; i < count; i++)
    {
      cmenu[i].nr = i + 1;
      cmenu[i].str = channels[i]->name;
      if (channels[i]->key)
        {
          sprintf (str, "%-*s %s", max + 2, channels[i]->name,
                   channels[i]->key);
          cmenu[i].str = strdup (str);
        }
    }
  editor_list_update ();
}

void
zap_timeout (XtPointer client_data, XtIntervalId * id)
{
  static int muted = 0;

  if (zap_fast && !cur_mute)
    {
      /* mute for fast channel scan */
      muted = cur_mute = 1;
      set_volume ();
    }
  pixit ();
  cur_sender = (cur_sender + 1) % count;
  set_channel (channels[cur_sender]);
  if (cur_sender != zap_start)
    {
      sprintf (title, "Hop: %s", channels[cur_sender]->name);
      XtVaSetValues (app_shell, XtNtitle, title, NULL);
      display_onscreen ();
      zap_timer = XtAppAddTimeOut
        (app_context, zap_fast ? CAP_TIME : ZAP_TIME, zap_timeout, NULL);
    }
  else
    {
      if (muted)
        {
          muted = cur_mute = 0;
          set_volume ();
        }
    }
}

void
ZapAction (Widget widget, XEvent * event,
           String * params, Cardinal * num_params)
{
  if (zap_timer)
    {
      XtRemoveTimeOut (zap_timer);
      zap_timer = 0;
      strcpy (title, "channel hopping off");
      set_timer_title ();
    }
  else
    {
      zap_start = (cur_sender == -1) ? 0 : cur_sender;
      zap_fast = 0;
      if (*num_params > 0)
        {
          if (0 == strcasecmp (params[0], "fast"))
            zap_fast = 1;
        }
      if (count)
        zap_timer = XtAppAddTimeOut
          (app_context, CAP_TIME, zap_timeout, NULL);
    }
}

/*--- option window ------------------------------------------------------*/

struct CALL_ACTION call_ptr = { 0, "Pointer", {NULL} };
struct CALL_ACTION call_cap = { 2, "SetRes", {"capture", "toggle", NULL} };
struct CALL_ACTION call_mute = { 1, "Volume", {"mute", NULL} };
struct CALL_ACTION call_alevt = { 0, "AleVT", {NULL} };
struct CALL_ACTION call_fs = { 1, "FullScreen", {"mute", NULL} };

struct CALL_ACTION call_gjpeg = { 1, "Snap", {"jpeg", NULL} };
struct CALL_ACTION call_gppm = { 1, "Snap", {"ppm", NULL} };

struct CALL_ACTION call_chan = { 0, "Channels", {NULL} };
struct CALL_ACTION call_editor = { 0, "Editor", {NULL} };
struct CALL_ACTION call_zap = { 0, "Zap", {NULL} };

void
action_cb (Widget widget, XtPointer clientdata, XtPointer call_data)
{
  struct CALL_ACTION *ca = clientdata;

  XtCallActionProc (widget, ca->name, NULL, ca->argv, ca->argc);
}

void
menu_cb (Widget widget, XtPointer clientdata, XtPointer call_data)
{
  int cd = (int) clientdata;
  int j;

  switch (cd)
    {
      /* Option window entries */
    case 10:
      if (-1 !=
          (j = popup_menu (widget, "TV Norm", grabbers[grabber]->norms)))
        set_norm (j);
      break;

    case 11:
      if (-1 != (j = popup_menu (widget, "Video Source",
                                 grabbers[grabber]->inputs)))
        set_source (j);
      break;

    case 12:
      if (-1 != (j = popup_menu (widget, "Freq table", chan_names)))
        set_freqtab (j);
      break;

    case 13:
      if (-1 != (j = popup_menu (widget, "Audio", stereo)))
        {
          change_audio (j);
        }
      break;

    case 14:
      if (-1 != (j = popup_menu (widget, "Capture", cap_list)))
        {
          set_capture (j);
        }
      break;

    case 15:
      if (-1 != (j = popup_menu (widget, "Deinterlace", deinterlace_list)))
        {
          set_deinterlace (j);
        }
      break;

    case 16:
      if (-1 != (j = popup_menu (widget, "Stay on Top", yes_no_list)))
        {
          set_stayontop (j);
        }
      break;

#if defined(HAVE_DIVX4LINUX) || defined(HAVE_FFMPEG) || defined(HAVE_XVID)
    case 17:
      if (-1 != (j = popup_menu (widget, "Record movie", record_list)))
        {
          record_movie (j);
        }
      break;
#endif

    case 18:
      if (-1 != (j = popup_menu (widget, "Window Decoration", yes_no_list)))
        {
          set_decoration (j);
        }
      break;

    default:
      break;
    }

  if (title[0] != 0)
    set_timer_title ();
}


void
jump_scb (Widget widget, XtPointer clientdata, XtPointer call_data)
{
  char *name;
  int value;
  char *msg = (char *)NULL;

  name = XtName (XtParent (widget));
  value = (int) (*(float *) call_data * 65535);
#if 0
  fprintf (stderr, "jump to %f (%s/%d)\n", *(float *) call_data, name, value);
#endif

  if (0 == strcmp ("color", name))
    set_picparams (value, -1, -1, -1);

  else if (0 == strcmp ("contrast", name))
    set_picparams (-1, -1, -1, value);

  else if (0 == strcmp ("bright", name))
    set_picparams (-1, value, -1, -1);

  else if (0 == strcmp ("hue", name))
    set_picparams (-1, -1, value, -1);

  else if (0 == strcmp ("volume", name))
    {
      //cur_mute = 0;
      cur_volume = value;
      if (plugin != NULL)
        msg = plugin->use_alternate();
    
      if (msg != (char *)NULL)
        set_volume_alternate ();
      else
        set_volume ();
    }

}

void
scroll_scb (Widget widget, XtPointer clientdata, XtPointer call_data)
{
  int move = (int) call_data;
  Dimension length;
  float shown, top1, top2;

  XtVaGetValues (widget,
                 XtNlength, &length,
                 XtNshown, &shown, XtNtopOfThumb, &top1, NULL);

  top2 = top1 + (float) move / length / 5;
  if (top2 < 0)
    top2 = 0;
  if (top2 > 1)
    top2 = 1;

#if 0
  fprintf (stderr, "scroll by %d\tlength %d\tshown %f\ttop %f => %f\n",
           move, length, shown, top1, top2);
#endif

  jump_scb (widget, clientdata, &top2);
}

void
OptionsAction (Widget widget, XEvent * event,
               String * params, Cardinal * num_params)
{
  static int mapped = 0, first = 1;

  if (event && event->type == ClientMessage)
    {
      if (event->xclient.data.l[0] == wm_protocols[1])
        {
          if (debug)
            fprintf (stderr, "Options: wm_save_yourself\n");
          XSetCommand (XtDisplay (opt_shell), XtWindow (opt_shell), NULL, 0);
          return;
        }
    }

  if (mapped)
    {
      XtPopdown (opt_shell);
      mapped = 0;
    }
  else
    {
      XtPopup (opt_shell, XtGrabNone);
      mapped = 1;
      if (first)
        {
          XSetWMProtocols (XtDisplay (opt_shell), XtWindow (opt_shell),
                           wm_protocols, 2);
          first = 0;
        }
    }
}

void
create_optwin ()
{
  Widget c, p, l;

  opt_shell = XtVaAppCreateShell ("Options", "Xawdecode",
                                  topLevelShellWidgetClass,
                                  dpy, XtNclientLeader, app_shell, NULL);
  opt_paned = XtVaCreateManagedWidget ("paned", panedWidgetClass, opt_shell,
                                       NULL);


  c = XtVaCreateManagedWidget ("mute", commandWidgetClass, opt_paned,
                               PANED_FIX, NULL);
  XtAddCallback (c, XtNcallback, action_cb, (XtPointer) & call_mute);


  c = XtVaCreateManagedWidget ("ptr", commandWidgetClass, opt_paned,
                               PANED_FIX, NULL);
  XtAddCallback (c, XtNcallback, action_cb, (XtPointer) & call_ptr);


  c = XtVaCreateManagedWidget ("fs", commandWidgetClass, opt_paned,
                               PANED_FIX, NULL);
  XtAddCallback (c, XtNcallback, action_cb, (XtPointer) & call_fs);


if (wm_stay_on_top)
  {
    c_stayontop = XtVaCreateManagedWidget ("stayontop", commandWidgetClass, opt_paned,
                                           PANED_FIX, NULL);
    XtAddCallback (c_stayontop, XtNcallback, menu_cb, (XtPointer) 16);
    /*
    sprintf (label, "%-" LABEL_WIDTH "s: %s", "Stay on Top",
    int_to_str(STAYONTOP_NO, stayontop_list));
    XtVaSetValues (c_stayontop, XtNlabel, label, NULL);
    */
  }


  c_decoration = XtVaCreateManagedWidget ("decoration", commandWidgetClass, opt_paned,
                                         PANED_FIX, NULL);
  XtAddCallback (c_decoration, XtNcallback, menu_cb, (XtPointer) 18);


  c = XtVaCreateManagedWidget ("grabppm", commandWidgetClass, opt_paned,
                               PANED_FIX, NULL);
  XtAddCallback (c, XtNcallback, action_cb, (XtPointer) & call_gppm);


#ifdef HAVE_LIBJPEG
  c = XtVaCreateManagedWidget ("grabjpeg", commandWidgetClass, opt_paned,
                               PANED_FIX, NULL);
  XtAddCallback (c, XtNcallback, action_cb, (XtPointer) & call_gjpeg);
#endif


#if defined(HAVE_DIVX4LINUX) || defined(HAVE_FFMPEG) || defined(HAVE_XVID)
    c_record = XtVaCreateManagedWidget ("record", commandWidgetClass, opt_paned,
                                           PANED_FIX, NULL);
    XtAddCallback (c_record, XtNcallback, menu_cb, (XtPointer) 17);
    /*
    sprintf (label, "%-" LABEL_WIDTH "s: %s", "Record movie",
             int_to_str(RECORD_STOP, record_list));
    XtVaSetValues (c_record, XtNlabel, label, NULL);
    */
#endif

  c = XtVaCreateManagedWidget ("alevt", commandWidgetClass, opt_paned,
                               PANED_FIX, NULL);
  XtAddCallback (c, XtNcallback, action_cb, (XtPointer) & call_alevt);


  c = XtVaCreateManagedWidget ("chanwin", commandWidgetClass, opt_paned,
                               PANED_FIX, NULL);
  XtAddCallback (c, XtNcallback, action_cb, (XtPointer) & call_chan);


  c = XtVaCreateManagedWidget ("editorwin", commandWidgetClass, opt_paned,
                               PANED_FIX, NULL);
  XtAddCallback (c, XtNcallback, action_cb, (XtPointer) & call_editor);


  c = XtVaCreateManagedWidget ("zap", commandWidgetClass, opt_paned,
                               PANED_FIX, NULL);
  XtAddCallback (c, XtNcallback, action_cb, (XtPointer) & call_zap);


  c_norm = XtVaCreateManagedWidget ("norm", commandWidgetClass, opt_paned,
                                    PANED_FIX, NULL);
  XtAddCallback (c_norm, XtNcallback, menu_cb, (XtPointer) 10);


  c_input = XtVaCreateManagedWidget ("input", commandWidgetClass, opt_paned,
                                     PANED_FIX, NULL);
  XtAddCallback (c_input, XtNcallback, menu_cb, (XtPointer) 11);


  c_freq = XtVaCreateManagedWidget ("freq", commandWidgetClass, opt_paned,
                                    PANED_FIX, NULL);
  XtAddCallback (c_freq, XtNcallback, menu_cb, (XtPointer) 12);


  c_audio = XtVaCreateManagedWidget ("audio", commandWidgetClass, opt_paned,
                                     PANED_FIX, NULL);
  XtAddCallback (c_audio, XtNcallback, menu_cb, (XtPointer) 13);


  c_cap = XtVaCreateManagedWidget ("cap", commandWidgetClass, opt_paned,
                                   PANED_FIX, NULL);
  XtAddCallback (c_cap, XtNcallback, menu_cb, (XtPointer) 14);


#ifdef HAVE_XV
  c_deinterlace = XtVaCreateManagedWidget ("deinterlace", commandWidgetClass, opt_paned,
                                           PANED_FIX, NULL);
  XtAddCallback (c_deinterlace, XtNcallback, menu_cb, (XtPointer) 15);
#endif


  p = XtVaCreateManagedWidget ("bright", panedWidgetClass, opt_paned,
                               XtNorientation, XtEvertical, PANED_FIX, NULL);

  l = XtVaCreateManagedWidget ("l", labelWidgetClass, p,
                               XtNshowGrip, False, NULL);

  s_bright = XtVaCreateManagedWidget ("s", scrollbarWidgetClass, p,
                                      PANED_FIX, NULL);

  XtAddCallback (s_bright, XtNjumpProc, jump_scb, NULL);

  XtAddCallback (s_bright, XtNscrollProc, scroll_scb, NULL);

  p = XtVaCreateManagedWidget ("hue", panedWidgetClass, opt_paned,
                               XtNorientation, XtEvertical, PANED_FIX, NULL);

  l = XtVaCreateManagedWidget ("l", labelWidgetClass, p,
                               XtNshowGrip, False, NULL);

  s_hue = XtVaCreateManagedWidget ("s", scrollbarWidgetClass, p,
                                   PANED_FIX, NULL);

  XtAddCallback (s_hue, XtNjumpProc, jump_scb, NULL);

  XtAddCallback (s_hue, XtNscrollProc, scroll_scb, NULL);

  p = XtVaCreateManagedWidget ("contrast", panedWidgetClass, opt_paned,
                               XtNorientation, XtEvertical, PANED_FIX, NULL);

  l = XtVaCreateManagedWidget ("l", labelWidgetClass, p,
                               XtNshowGrip, False, NULL);

  s_contrast = XtVaCreateManagedWidget ("s", scrollbarWidgetClass, p,
                                        PANED_FIX, NULL);

  XtAddCallback (s_contrast, XtNjumpProc, jump_scb, NULL);

  XtAddCallback (s_contrast, XtNscrollProc, scroll_scb, NULL);

  p = XtVaCreateManagedWidget ("color", panedWidgetClass, opt_paned,
                               XtNorientation, XtEvertical, PANED_FIX, NULL);

  l = XtVaCreateManagedWidget ("l", labelWidgetClass, p,
                               XtNshowGrip, False, NULL);

  s_color = XtVaCreateManagedWidget ("s", scrollbarWidgetClass, p,
                                     PANED_FIX, NULL);

  XtAddCallback (s_color, XtNjumpProc, jump_scb, NULL);

  XtAddCallback (s_color, XtNscrollProc, scroll_scb, NULL);

  p = XtVaCreateManagedWidget ("volume", panedWidgetClass, opt_paned,
                               XtNorientation, XtEvertical, PANED_FIX, NULL);

  l = XtVaCreateManagedWidget ("l", labelWidgetClass, p,
                               XtNshowGrip, False, NULL);

  s_volume = XtVaCreateManagedWidget ("s", scrollbarWidgetClass, p,
                                      PANED_FIX, NULL);

  XtAddCallback (s_volume, XtNjumpProc, jump_scb, NULL);

  XtAddCallback (s_volume, XtNscrollProc, scroll_scb, NULL);

  if (plugin != NULL)
    plugin->add_entry(opt_paned);

  c = XtVaCreateManagedWidget ("save_config", commandWidgetClass, opt_paned,
                               PANED_FIX, NULL);
  XtAddCallback (c, XtNcallback, save_cb, (XtPointer) NULL);

  c = XtVaCreateManagedWidget ("quit", commandWidgetClass, opt_paned,
                               PANED_FIX, NULL);

  XtAddCallback (c, XtNcallback, ExitCB, NULL);
}


/*--- grab (single frames) to file ---------------------------------------*/


void
SnapAction (Widget widget, XEvent * event,
            String * params, Cardinal * num_params)
{
  void *buffer;
  int jpeg = 0;
  char *filename = NULL;
  char *snapbase = NULL;
  char *name = NULL;
  Dimension width = maxwidth[cur_norm];
  Dimension height = maxheight[cur_norm];

  if (*num_params > 0)
    {
      if (0 == strcasecmp (params[0], "jpeg"))
        jpeg = 1;
      if (0 == strcasecmp (params[0], "ppm"))
        jpeg = 0;
    }

  if (*num_params > 1)
    {
      if (0 == strcasecmp (params[1], "full"))
        {
          width = maxwidth[cur_norm];
          height = maxheight[cur_norm];
        }
      if (0 == strcasecmp (params[1], "win"))
        XtVaGetValues (tv, XtNwidth, &width, XtNheight, &height, NULL);
    }

  if (!grabbers[grabber]->grab_one)
    {
      fprintf (stderr, "grabbing: not supported\n");
      return;
    }

  strcpy (title, "grabbing...");
  set_timer_title ();

  if (NULL == (buffer = grabbers[grabber]->grab_one (-1, width, height)))
    {
      strcpy (title, "grabbing failed");
      set_timer_title ();
      return;
    }

  if (NULL == filename)
    {
      if (NULL == snapbase)
        {
          if (jpeg && (jpegfile != NULL))
            snapbase = jpegfile;
          else if (!jpeg && (ppmfile != NULL))
            snapbase = ppmfile;
          else
            {
              snapbase = (char *) malloc (5);
              strcpy (snapbase, "snap");
            }
        }
      if (-1 != cur_sender)
        {
          name = channels[cur_sender]->name;
          /*
             } else if (-1 != cur_channel) {
             name = chanlist[cur_channel].name;
           */
        }
      else
        {
          name = "???";
        }
      filename = snap_filename (snapbase, name, jpeg ? "jpeg" : "ppm");
    }

  if (jpeg)
    {
#ifdef HAVE_LIBJPEG
      write_jpeg (filename, buffer, width, height, 75, 0);
      sprintf (title, "saved jpeg: %s", filename);
      //patch_up(jpegfile);
#else
      sprintf (title, "no jpeg support, sorry");
#endif
    }
  else
    {
      write_ppm (filename, buffer, width, height);
      sprintf (title, "saved ppm: %s", filename);
      //patch_up(ppmfile);
    }

  set_timer_title ();

  /* set parameters to main window size */
  //grabber_setparams(x11_pixmap_format,&grab_width,&grab_height,
  //                &grab_linelength,1);

  if (snapbase != (char *) NULL)
    free (snapbase);
}

/*--- main-------------------------------------------------------------*/

static void
xfree_init ()
{
  int flags, foo, bar, i, ma, mi;

#ifdef HAVE_LIBXXF86DGA
  if (!noDGA)
    {
      if (XF86DGAQueryExtension (dpy, &foo, &bar))
        {
          XF86DGAQueryDirectVideo (dpy, XDefaultScreen (dpy), &flags);
          if (flags & XF86DGADirectPresent)
            {
              XF86DGAQueryVersion (dpy, &ma, &mi);
              fprintf (stderr, "DGA: server=%d.%d, include=%d.%d\n",
                       ma, mi, XF86DGA_MAJOR_VERSION, XF86DGA_MINOR_VERSION);
              if ((ma != XF86DGA_MAJOR_VERSION) || (mi != XF86DGA_MINOR_VERSION))
#ifdef CHECK_XFREE_EXT
                fprintf (stderr, "DGA: version mismatch -- disabled\n");
              else
#else
                fprintf (stderr, "DGA: WARNING: version mismatch !!!\n");
#endif
                have_dga = 1;
            }
        }
    }
#endif
#ifdef HAVE_LIBXXF86VM
  if (XF86VidModeQueryExtension (dpy, &foo, &bar))
    {
      XF86VidModeQueryVersion (dpy, &ma, &mi);
      fprintf (stderr, "VidMode: server=%d.%d, include=%d.%d\n",
               ma, mi, XF86VIDMODE_MAJOR_VERSION, XF86VIDMODE_MINOR_VERSION);
      if ((ma != XF86VIDMODE_MAJOR_VERSION)
          || (mi != XF86VIDMODE_MINOR_VERSION))
#ifdef CHECK_XFREE_EXT
        fprintf (stderr, "VidMode: version mismatch -- disabled\n");
      else
#else
        fprintf (stderr, "VidMode: WARNING: version mismatch !!!\n");
#endif
        {
          have_vm = 1;
          fprintf (stderr, "  available video mode(s):");
          XF86VidModeGetAllModeLines (dpy, XDefaultScreen (dpy),
                                      &vm_count, &vm_modelines);
          for (i = 0; i < vm_count; i++)
            {
              fprintf (stderr, " %dx%d",
                       vm_modelines[i]->hdisplay, vm_modelines[i]->vdisplay);
            }
          fprintf (stderr, "\n");
        }
    }
#endif
}

static void
grabber_init ()
{
  int sw, sh;
  void *base = NULL;
  int width = 0, depth = 0;
#ifdef HAVE_LIBXXF86DGA
  int bar, fred;

  if (have_dga)
    {
      XF86DGAGetVideoLL (dpy, XDefaultScreen (dpy), (int *) &base,
                         &width, &bar, &fred);
    }
#endif
  sw = XtScreen (app_shell)->width;
  sh = XtScreen (app_shell)->height;

  if (0 == width)
    width = sw;
  switch (x11_native_format)
    {
    case VIDEO_GRAY:
    case VIDEO_RGB08:
      depth = 8;
      break;
    case VIDEO_RGB15:
      depth = 15;
      break;
    case VIDEO_RGB16:
      depth = 16;
      break;
    case VIDEO_RGB24:
      depth = 24;
      break;
    case VIDEO_RGB32:
      depth = 32;
      break;
    }
  width *= (depth + 7) / 8;
  fprintf (stderr, "x11: %dx%d, %d bit/pixel, %d byte/scanline\n",
           sw, sh, depth, width);

  for (grabber = 0;
       grabber < sizeof (grabbers) / sizeof (struct GRABBERS *); grabber++)
    {
      if (-1 != grabbers[grabber]->grab_open
          (&device, sw, sh, x11_native_format, x11_pixmap_format, base,
           width ? width : sw))
        break;
    }
  if (grabber == sizeof (grabbers) / sizeof (struct GRABBERS *))
    {
      fprintf (stderr, "no video grabber device available\n");
      exit (1);
    }
  if(grabbers[grabber]==&grab_dummy) 
    {
      fprintf(stderr, "no video grabber device available\n");
      fprintf(stderr, "USE DUMMY DRIVER !\n");
    }
  
  /* Start sound acquisition */
  if (grabbers[grabber]->grab_audio)
    grabbers[grabber]->grab_audio (cur_mute, cur_volume, NULL);
}

void
AleVTAction (Widget widget, XEvent * event,
             String * params, Cardinal * num_params)
{
#ifdef ALEVT_ENABLED
  if (alevt_in_use == 1)
    stop_alevt();
  else
    // Need to supply at least what should be considered as argv[0]
    start_alevt("alevt");
#endif
}

void
display_help_message (FILE *fp)
{
  int i;

  fprintf(fp, "Valid Options are:\n\n");
  i = 0;
  while (help_msg[i] != NULL)
    {
      fprintf(fp, "%s\n\n", help_msg[i]);
      i++;
    }

  if (plugin)
    plugin->display_help_message(fp);

}

void load_plugin (void)
{
// 1.4.0
#define EXPECTED 0x010400

#define MAJOR(a) ( ( (a) >> 16 )&0xFF)
#define MINOR(a) ( ( (a) >> 8 )&0xFF )
#define SUB(a)   ( (a)&0xFF )

  char *error;
  unsigned int *plugin_version;
  int version_error = 0;

  hPlugin = dlopen("libxawdecode.so", RTLD_NOW);
  if (!hPlugin)
    {
      error = dlerror();
      fprintf(stderr, "%s\n", error);
      //fprintf(stderr, "Could not find a suitable pugin.\n");
      plugin = NULL;
    }
  else
    {
      plugin_version = dlsym(hPlugin, "version");
      if ((error = dlerror()) != NULL)
        {
          //fprintf(stderr, "%s\n", error);
          fprintf(stderr,
                  "WARNING: A plugin has been find but is unable to provide its version number.\n"
                  "         Make sure you have the latest plugin installed.\n");
          version_error = 1;
        }
      else if (*plugin_version < EXPECTED)
        {
          fprintf(stderr,
                  "WARNING: Plugin claims to be %d.%d.%d but %d.%d.%d at least is expected.\n",
                  MAJOR(*plugin_version), MINOR(*plugin_version), SUB(*plugin_version),
                  MAJOR(EXPECTED), MINOR(EXPECTED), SUB(EXPECTED));
          version_error = 1;
        }

      if (!version_error)
        {
          plugin = dlsym(hPlugin, "xawdecode");
          if ((error = dlerror()) != NULL)
            {
              fprintf(stderr, "%s\n", error);
              //fprintf(stderr, "WARNING: a plugin has been find but does not appear to be usable.\n");
              plugin = NULL;
            }
        }
      else
        {
          dlclose(hPlugin);
          hPlugin = NULL;
          plugin = NULL;
          fprintf(stderr, "WARNING: plugin has been disabled.\n");
        }
    }
}

int
check_mmx(void)
{
  int mmx_flags;

  if ( (mmx_flags = mm_accel ()) == 0 )
    {
      fprintf (stderr, "No MMX detected: deinterlacing will not be available!\n\n");
      return 0;
    }
  
  if (mmx_flags & MM_ACCEL_X86_MMX)
    fprintf(stderr, "MMX, ");
  if (mmx_flags & MM_ACCEL_X86_SSE) 
    fprintf(stderr, "SSE, ");
  if (mmx_flags & MM_ACCEL_X86_MMXEXT)
    fprintf(stderr, "AMD MMX extensions, ");
  if (mmx_flags & MM_ACCEL_X86_SSE2)
    fprintf(stderr, "SSE2, ");
  if (mmx_flags & MM_ACCEL_X86_3DNOW)
    fprintf(stderr, "3DNOW, ");
  fprintf(stderr, "have been detected.\n");

  return mmx_flags;
}

void
check_device_old_way(void)
{ 
#ifdef HAVE_DEVFS

  struct stat buf;

  /* Check for really default available video device */
  if (stat (device.video, &buf) != 0)
    {
      /* default video device does not exist at all */
      /* last chance ? */
      device.video = "/dev/v4l/video0";
    }


  /* Check for really default available vbi device */
  if (stat (device.vbi, &buf) != 0)
    {
      /* default vbi device does not exist at all */
      /* last chance ? */
      device.vbi = "/dev/v4l/vbi0";
    }

#else

  struct stat buf;

  /* Check for really default available video device */
  if (stat (device.video, &buf) == 0)
    {
      /* is it a directory */
      if (S_ISDIR (buf.st_mode))
        {
          /* New fucking idea of Mandrake and RedHat */
          device.video = "/dev/video/video0";

          /* Quickly check if that device exists */
          if (stat (device.video, &buf) != 0)
            {
              /* No, then defaults to /dev/video0 (last chance ?) */
              device.video = "/dev/video0";
            }
        }
    }
  else
    /* default video device does not exist at all */
    {
      /* last chance ? */
      device.video = "/dev/video0";
    }


  /* Check for really default available vbi device */
  if (stat (device.vbi, &buf) == 0)
    {
      /* is it a directory */
      if (S_ISDIR (buf.st_mode))
        {
          /* New fucking idea of Mandrake and RedHat */
          device.vbi = "/dev/video/vbi0";

          /* Quickly check if that device exists */
          if (stat (device.vbi, &buf) != 0)
            {
              /* No, then defaults to /dev/vbi0 (last chance ?) */
              device.vbi = "/dev/vbi0";
            }
        }
    }
  else
    /* default vbi device does not exist at all */
    {
      /* last chance ? */
      device.vbi = "/dev/vbi0";
    }

#endif
  if (debug)
    {
      fprintf(stderr, "Selected default video device : %s\n", device.video);
      fprintf(stderr, "Selected default vbi device   : %s\n", device.vbi);
    }
}

void
check_device(void)
{
  int n;
  struct dirent **namelist;
  FILE *fp;
  char line [128];
  char *test_string;
  char **test_device;

  /* Read entries in /proc/video/dev */
  n = scandir("/proc/video/dev", &namelist, 0, 0);
  if (debug)
    fprintf(stderr, "Get %d files in /proc/video/dev\n", n);
  if (n <= 0)
    {
      // something odd occured, fallback to old detection way
      if (n<0) perror("sacandir");
      check_device_old_way();
      return;
    }
  else
    {
      while (n--)
        {
          if ((strcmp(namelist[n]->d_name, "..")==0)||(strcmp(namelist[n]->d_name, ".")==0))
            break;

          if (debug)
            fprintf(stderr, "Checking file /proc/video/dev/%s\n", namelist[n]->d_name);
          if (strncmp(namelist[n]->d_name, "video", 5)== 0)
            {
              test_string = "VID_TYPE_TUNER";
              test_device = &device.video;
            }
          else if (strncmp(namelist[n]->d_name, "vbi", 3)== 0)
            {
              test_string = "VID_TYPE_TELETEXT";
              test_device = &device.vbi;
            }
          else
            {
              test_string = NULL;
              test_device = NULL;
            }
            
          if (test_string != NULL)
            {
              sprintf(line, "/proc/video/dev/%s", namelist[n]->d_name);
              fp = fopen(line, "r");
              while (NULL != fgets (line, 127, fp))
                {
                  line[strlen(line)-1] = 0;
                  if (debug)
                    fprintf(stderr, "Checking line: '%s'\n", line);
                  if ( (strncmp(line, "type", 4) == 0) && strstr(line, test_string) )
                    {
                      if (debug)
                        fprintf(stderr, "Bingo!\n");
                      *test_device = malloc(16);
#ifndef HAVE_DEVFS
                      sprintf(*test_device, "/dev/%s", namelist[n]->d_name);
#else
                      sprintf(*test_device, "/dev/v4l/%s", namelist[n]->d_name);
#endif
                    }
                }
              fclose(fp);
            }
          free(namelist[n]);
        }
      free(namelist);
    }

  if (debug)
    {
      fprintf(stderr, "Selected default video device : %s\n", device.video);
      fprintf(stderr, "Selected default vbi device   : %s\n", device.vbi);
    }
}

#define INCRARG if(++i>=argc) {display_help_message(stderr); exit(0);}

static Boolean docmd (XtPointer data) {
  printf("effectu\n");
  if(cmd) {do_command_mult(cmd);cmd=NULL;}
  return -1; /* on ne l'execute qu'une seule fois...*/
}

int
main (int argc, char *argv[])
{
  int i, noconf, fullscreen, nodecoration, nomouse;
  char *arg;
  char v4l_conf[128] = "v4l-conf -q";
  Dimension w;
#ifdef HAVE_XPM
  Pixmap icon_pixmap;
  Pixmap icon_shapemask;
#endif
  struct utsname uts;
  int noplugin = 0;
  struct CHANNEL last_channel;
  int cmdline_probe_memcpy = -1;
  struct sigaction sa;

  progname = strdup (argv[0]);

  uname(&uts);
  fprintf (stderr, "\nThis is %s %s running on %s/%s (%s).\n",
           PACKAGE, VERSION, uts.sysname, uts.machine, uts.release);


  XInitThreads ();


  app_shell = XtAppInitialize (&app_context, "Xawdecode", NULL, 0,    /* opt_desc, 7, */
                               &argc, argv, NULL /* fallback_res */ ,
                               NULL, 0);
  /* signal handler */
  memset(&sa, 0, sizeof(sa));
  sa.sa_handler = sigint_handler;
  sa.sa_flags = SA_RESTART;
  sigaction(SIGINT,  &sa, NULL);

  /* Check for really default available device */
  check_device();

  for (i = 1; i < argc; i++)
    {
      if (strcmp (argv[i], "-noplugin") == 0)
        {
          noplugin = 1;
        }
    }
  
  if (!noplugin)
    {
      load_plugin();
    }

  /* parse options */
  debug = noconf = fullscreen = nodecoration =nomouse = 0;
  xfree_ext = 1;

  for (i = 1; i < argc; i++)
    {
      arg = argv[i];
      if (strcmp (arg, "-x") == 0)
        {
          xfree_ext = 0;
        }
      else if (strcmp (arg, "-v") == 0)
        {
          INCRARG;
          debug = strtol (argv[i], (char **) NULL, 10);
        }
      else if (strcmp (arg, "-n") == 0)
        {
          noconf = 1;
        }
      else if (strcmp (arg, "-d") == 0)
        {
          noDGA = 1;
        }
      else if (strcmp (arg, "-m") == 0)
        {
          nomouse = 1;
        }
      else if (strcmp (arg, "-f") == 0)
        {
          fullscreen = 1;
        }
      else if (strcmp (arg, "-nowd") == 0)
         {
           nodecoration = 1;
         }
      else if (strcmp (arg, "-b") == 0)
        {
          INCRARG;
	  bpp = strtol (argv[i], (char **) NULL, 10);
          /* v4l-conf needs this too */
          strcat (v4l_conf, " -b ");
          strcat (v4l_conf, optarg);
        }
      else if (strcmp (arg, "-o") == 0)
        {
          ppmfile = arg;
        }
      else if (strcmp (arg, "-o") == 0)
        {
          jpegfile = arg;
        }
      else if (strcmp (arg, "-c") == 0)
        {
          INCRARG;
          device.video = argv[i];
          /* v4l-conf needs this too */
          //strcat (v4l_conf, " -c ");
          //strcat (v4l_conf, device);
        }
      else if (strcmp (arg, "-C") == 0)
        {
          INCRARG;
          device.vbi = argv[i];
        }
      else if ((strcmp (arg, "-no-xv") == 0) || (strcmp (arg, "-noxv") == 0))
        {
#ifdef HAVE_XV
          disable_xv = 1;
          fprintf (stderr, "Xv support disabled.\n");
#else
          fprintf (stderr,
                   "Xv support was not compiled in. Option ignored.\n");
#endif
        }
      else if (strcmp (arg, "-xvport") == 0)
        {
#ifdef HAVE_XV
          INCRARG;
          cmdline_xv_img_port = atoi(argv[i]);
#else
          fprintf (stderr,
                   "Xv support was not compiled in. Option ignored.\n");
#endif
        }
      else if (strcmp(arg, "-hwscan") == 0)
        {
          hwscan = 1;
        }
      else if (strcmp(arg, "-noplugin") == 0)
        {
          noplugin = 1; // just to avoid xawdecode exiting
        }
      else if (strcmp (arg, "-probe_memcpy") == 0)
        {
          cmdline_probe_memcpy = MEMCPY_PROBE;
        }
      else if ((strcmp(arg, "-h") == 0)||strcmp(arg, "--help") == 0)
        {
          fprintf (stdout, "\nUsage: %s [options]\n\n", argv[0]);
          display_help_message(stdout);
          exit(0);
        }
#if defined(HAVE_DIVX4LINUX) || defined(HAVE_FFMPEG) || defined (HAVE_XVID)
      else if (strcmp (arg, "-rec_fps") == 0)
        {
          INCRARG;
	  setfps(atof(argv[i]));
        }
      else if (strcmp (arg, "-rec_width") == 0)
        {
          INCRARG;
	  divx.width=atol(argv[i]);;
	  divx.height=3*divx.width/4;
        }
      else if (strcmp (arg, "-rec_videobr") == 0)
        {
          INCRARG;
	  divx.bitrate=atol(argv[i])*1000L;
        }
      else if (strcmp (arg, "-rec_mp3cbr") == 0)
        {
          INCRARG;
	  divx.mp3_bitrate=atoi(argv[i]);
	  divx.mp3_vbr=0;
        }
      else if (strcmp (arg, "-rec_mp3vbr") == 0)
	{
          INCRARG;
	  divx.mp3_vbr_quality=atoi(argv[i]);
	  divx.mp3_quality=2;
	  divx.mp3_vbr=1;
        }
      else if (strcmp (arg, "-rec_vcodec") == 0)
        {
	  int j;
	  struct {char *nom;int numcodec;} codecs[]= {
#ifdef HAVE_FFMPEG
	    {"ffmpeg_mpeg4",FFMPEG_MPEG4},
	    {"ffmpeg_mpeg1",FFMPEG_MPEG1},
#endif
#ifdef HAVE_XVID
	    {"xvid",XVID},
#endif
#ifdef HAVE_DIVX4LINUX
	    {"divx4linux",DIVX4LINUX},
#endif
	    {NULL,0}};
	  INCRARG;
	  for(j=0;codecs[j].nom;j++) {
	    printf("%s\n",codecs[j].nom);
	    if(!strcmp(argv[i],codecs[j].nom)) break;
	  }
	  if(!codecs[j].nom) 
	    {
	      fprintf(stderr,"codec %s inconnu\n",argv[i]);
	      exit(1);
	    }	     
	  divx.codec=codecs[j].numcodec;
	}
      else if (strcmp (arg, "-rec_display") == 0)
        {
	  INCRARG;
	  divx.display_frames=atoi(argv[i]); 
        }
      else if (strcmp (arg, "-rec_maxgap") == 0)
        {
	  INCRARG;
	  divx.maxgap=atof(argv[i]); 
        }
#endif
      else if (strcmp (arg, "-e") == 0)
        {
	  INCRARG;
	  cmd = argv[i]; 
        }
      else
        {
          int ret = -1;
       	  if (plugin != NULL)
    	    ret = plugin->parse_cmdline(&i, argv);
          if (ret == -1)
            {
              fprintf (stderr, "\nUnknown option: '%s'.\n\n", arg);
              fprintf (stderr, "Usage: %s [options]\n\n", argv[0]);
              display_help_message(stderr);
              exit (1);
            }
        }
    }

  // This is now done here as device may have been
  // modified either by the check_device function
  // or by supplying the -c switch
  strcat (v4l_conf, " -c ");
  strcat (v4l_conf, device.video);

  if (hwscan == 1)
    {
      fprintf(stderr,"looking for available devices\n\n");
      x11_init(XtDisplay(app_shell), XtWindow(app_shell));
      grabber_scan(XtScreen (app_shell)->width, XtScreen (app_shell)->height);
    }

  switch (system (v4l_conf))
    {
    case -1:                    /* can't run */
      fprintf (stderr, "could'nt start v4l-conf\n");
      break;
    case 0:                    /* ok */
      break;
    default:                    /* non-zero return */
      fprintf (stderr, "v4l-conf had some trouble, "
               "trying to continue anyway\n");
      break;
    }

  XtAppAddActions (app_context, actionTable,
                   sizeof (actionTable) / sizeof (XtActionsRec));
  wm_protocols[0] =
    XInternAtom (XtDisplay (app_shell), "WM_DELETE_WINDOW", False);

  wm_protocols[1] =
    XInternAtom (XtDisplay (app_shell), "WM_SAVE_YOURSELF", False);

  xawtv_station =
    XInternAtom (XtDisplay (app_shell), "_XAWTV_STATION", False);

  xawtv_remote = XInternAtom (XtDisplay (app_shell), "_XAWTV_REMOTE", False);

  dpy = XtDisplay (app_shell);

  wm_detect(dpy);

  if (xfree_ext)
    xfree_init ();


  create_optwin ();
  create_onscreen ();
  create_chanwin ();
  create_editorwin ();
#if defined(HAVE_DIVX4LINUX) || defined(HAVE_FFMPEG) || defined(HAVE_XVID)
  create_divxwin ();
#endif
  if (plugin != NULL)
    plugin->create_windows(app_shell);

  idle_grabdisplay = idle_grabdisplay1;

  tv = video_init (app_shell);
  // From here now, we really know if Xvideo is used or not
  // x11_pixmap_format and x11_native_format are initialized as well

#if defined(HAVE_DIVX4LINUX) || defined(HAVE_FFMPEG) || defined(HAVE_XVID)
  // Backup x11_pixmap_format in case of a plugin chages it
  divx_pixmap_format = x11_pixmap_format;
#endif

  XtVaGetValues (tv, XtNwidth, &w, NULL);
  if (!w)
    {
      fprintf (stderr, "The app-defaults file is not correctly installed.\n");
      fprintf (stderr,
               "You should have installed xawdecode by issuing \"make install\".\n");
      fprintf (stderr, "Your fault (core dumped).\n");
      exit (1);
    }

  if (plugin != NULL)
    plugin->ui_init(app_context, app_shell, tv);

  if (plugin != NULL)
    plugin->set_idle_grabdisplay((void **)&idle_grabdisplay);

  switch (bpp)
    {
    case 8:
      x11_native_format = VIDEO_RGB08;
      break;
    case 15:
      x11_native_format = VIDEO_RGB15;
      break;
    case 16:
      x11_native_format = VIDEO_RGB16;
      break;
    case 24:
      x11_native_format = VIDEO_RGB24;
      break;
    case 32:
      x11_native_format = VIDEO_RGB32;
      break;
    default:
      bpp = 0;
    }

  grabber_init ();

  /* Check for user directory */
  check_user_directory ();

  if (plugin != NULL)
    plugin->pre_config_init();

  /* read config file */
  if (!noconf)
    read_config ();

  /* Ensure everything (MMX, fast_memcpy) is OK for deinterlacing */
  have_MMX = check_mmx();
  if (cmdline_probe_memcpy != -1)
    probe_fast_memcpy(MEMCPY_PROBE);
  else
    {
      load_memcpy_method();
      probe_fast_memcpy(memcpy_method);
    }

  if (plugin != NULL)
    plugin->post_config_init();

#ifdef HAVE_XV
  if (!have_xv)
    {
      deinterlace_list[1].nr  = -1;
      deinterlace_list[1].str = NULL;
    }
#endif

  set_freqtab (chan_tab);
  channel_menu ();

  /* If mixer was not specified by config file, open it anyway */
  if (!have_mixer)
    {
      if (-1 != mixer_open ("/dev/mixer", mixer))
        have_mixer = 1;
    }


  if (have_mixer)
    cur_volume = mixer_get_volume () * 65535 / 100;

  set_volume ();
  cur_capture = 0;

  sprintf (modename, "%d x %d",
           XtScreen (app_shell)->width, XtScreen (app_shell)->height);
  switch (x11_native_format)
    {
    case VIDEO_RGB08:
      strcat (modename, " x 8 bit");
      break;
    case VIDEO_RGB15:
      strcat (modename, " x 15 bit");
      break;
    case VIDEO_RGB16:
      strcat (modename, " x 16 bit");
      break;
    case VIDEO_RGB24:
      strcat (modename, " x 24 bit");
      break;
    case VIDEO_RGB32:
      strcat (modename, " x 32 bit");
      break;
    }

  if (plugin != NULL)
    {
      if (-1 == plugin->init_colors(&bpp))
        return 1;
    }

#if 0
  strcat (modename, " - using ");
  strcat (modename, grabbers[grabber]->name);
#endif

#ifdef HAVE_XPM
  XpmCreatePixmapFromData(XtDisplay(app_shell),
                          RootWindowOfScreen(XtScreen(app_shell)),
                          icon_xpm,
                          &icon_pixmap,
                          &icon_shapemask, NULL);
  XtVaSetValues(app_shell, XtNiconPixmap, icon_pixmap, NULL);
#endif

  /* commandes externes */
  init_socket();

  /* lirc support */
  if (debug)
	fprintf(stderr,"main: checking for lirc ...\n");
  if (-1 != (lirc = lirc_tv_init()))
	XtAppAddInput(app_context,lirc,(XtPointer)XtInputReadMask,lirc_input,NULL);

  XtRealizeWidget (app_shell);
  create_pointers (app_shell);
  create_bitmaps (app_shell);
  XDefineCursor (dpy, XtWindow (app_shell), left_ptr);
  XSetWMProtocols (XtDisplay (app_shell), XtWindow (app_shell),
                   wm_protocols, 2);

  XtVaSetValues (app_shell,
                 XtNwidthInc, WIDTH_INC,
                 XtNheightInc, HEIGHT_INC,
                 XtNminWidth, WIDTH_INC, XtNminHeight, HEIGHT_INC, NULL);

  if (optind + 1 == argc)
    {
      for (i = 0; i < count; i++)
        if (0 == strcasecmp (channels[i]->name, argv[optind]))
          cur_sender = i;
    }

  if (count)
    {

      if ((load_last_channel(&last_channel)) == 0)
        {
          for (i = 0; i < count; i++)
            if (channels[i]->channel == last_channel.channel)
            {
              cur_sender = i;
              break;
            }

          //memcpy(channels[i], &last_channel, sizeof(struct CHANNEL));
          if ((cur_sender < 0) || (cur_sender >= count))
            cur_sender = 0;
          else
            update_channel(channels[cur_sender],  &last_channel);
          set_channel (channels[cur_sender]);
          pixit();
        }
      else
        {
          if ((cur_sender < 0) || (cur_sender >= count))
            cur_sender = 0;
          set_channel (channels[cur_sender]);
        }
    }
  else
    {
      set_channel (&defaults);
    }

  if (fullscreen)
  {
    FullScreenAction (NULL, NULL, NULL, NULL);
    nodecoration = 0 ;
  }
  else
    XtAppAddWorkProc (app_context, MyResize, NULL);
  if (nomouse)
    PointerAction (NULL, NULL, NULL, NULL);

   if (nodecoration)
     DecorationAction (NULL, NULL, NULL, NULL);
   else
   {
   // if no window decoration requested,
   // the first OSD position is not in the window
     strcpy (title, modename);
     set_timer_title ();
   }
  if (!have_config)
    XtCallActionProc (tv, "Help", NULL, NULL, 0);
  if(cmd && !idle_id) XtAppAddWorkProc (app_context, docmd, NULL);
  XtAppMainLoop (app_context);

  /* keep compiler happy */
  return 0;
}
