##############################################################################
# $Id: xawdecode.spec.in,v 1.10 2003/07/07 22:01:09 pingus77 Exp $
##############################################################################

%define _unpackaged_files_terminate_build 0

# build with -with optimization
%define build_optimization 0
%{?_with_optimization: %{expand: %%define build_optimization 1}}

# build with -with alsa
%define build_alsa 0
%{?_with_alsa: %{expand: %%define build_alsa 1}}

%define name 			xawdecode
%define Name 			Xawdecode
%define version 		1.7.0
%define release 		1mdk
%define summary1		%{Name} is a fork of xawtv that allows you to watch TV, record AVI files with possibility of plugin extensions.
%define summary2		Developpement files for %{Name}.
%define summary3		This is a small tool to configure a video4linux device driver.
%define summary4		Font used by %{Name} OSD function.
%define  tvtuner_launcher	%{_sysconfdir}/dynamic/launchers/tvtuner

Name: 				%{name}
Summary: 			%{summary1}
Version: 			%{version}
Release: 			%{release}
Copyright: 			GPL
Distribution: 			Mandrake Linux
Packager: 			Pingus <pingus77@ifrance.com>
URL:				http://xawdecode.sourceforge.net/
Source0:			%{name}-%{version}.tar.gz
Group: 				Video

Requires:			XFree86-libs
Requires:			libdivx4linux0 = 20030428
Requires:			libffmpeg0.4.6 = 0.4.6
Requires:			libmp3lame0 >= 3.93
Requires:			liblirc0
Requires:			libjpeg62
Requires:			xvid >= 0.9.0
Requires:			xterm

BuildRequires:			XFree86-devel
BuildRequires:			autoconf2.5
BuildRequires:			libdivx4linux0-devel = 20030428
BuildRequires:			libffmpeg0.4.6-devel = 0.4.6
BuildRequires:			libmp3lame0-devel >= 3.93
BuildRequires:			liblirc0-devel
BuildRequires:			libjpeg62-devel
BuildRequires:			xvid-devel >= 0.9.0

BuildRoot: 			%{_tmppath}/%{name}-%{version}-buildroot

%description
%{Name} is a fork of xawtv that allows you to watch TV, record AVI
files with possibility of plugin extensions.
It interacts with AleVT for Teletext and Nxtvepg for NextView signal,
%{Name} uses the video4linux API. It can use deinterlacing filters
%{Name} allows you to record video files with the xvid,
ffmpeg and divx4 codecs.

%package devel
Summary:			%{summary2}
Group:				Development/C
Requires:			%{name} = %{version}

%description devel
Developpement files for %{name}

%package v4l-conf
Summary:			%{summary3}
Group:				Video
Requires:			%{name} = %{version}
Conflicts:			xawtv-common

%description v4l-conf
This is a small tool to configure a video4linux device driver.
It is required to make the video overlay work in fbtv, xawtv and %{Name}

%package OSD-font
Summary:			%{summary4}
Group:				Video
Requires:			%{name} = %{version}

%description OSD-font
Font used by %{Name} OSD function.

%prep
rm -rf $RPM_BUILD_ROOT
%setup -a 0

%build
CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=%{_prefix} \
%if !%build_optimization
	--disable-cpu-detection \
%endif
%if !%build_alsa
	--disable-alsa
%endif
make

%install
make ROOT="$RPM_BUILD_ROOT" prefix="$RPM_BUILD_ROOT"%{_prefix} install
strip $RPM_BUILD_ROOT/%{_bindir}/xawdecode
strip $RPM_BUILD_ROOT/%{_bindir}/v4l-conf
strip $RPM_BUILD_ROOT/%{_bindir}/xawdecode_wizard

# Dynamic v4l support
mkdir -p $RPM_BUILD_ROOT%{tvtuner_launcher}
cat > $RPM_BUILD_ROOT%{tvtuner_launcher}/%{name}.desktop << EOF

[Desktop Entry]
Name=%{Name} \$basename
Comment=%{Name} allows you to watch TV, record AVI files with possibility of plugin extensions.
TryExec=%{_bindir}/%{name}
Exec=%{_bindir}/%{name}
Terminal=false
Icon=%{name}.png
Type=Application
EOF

# Cure man path
install -d -m 755 %{buildroot}%{_mandir}/man1/
install -m 644 %{name}.1 %{buildroot}%{_mandir}/man1/
install -m 644 %{name}_cmd.1 %{buildroot}%{_mandir}/man1/
bzip2 %{buildroot}%{_mandir}/man1/%{name}.1
bzip2 %{buildroot}%{_mandir}/man1/%{name}_cmd.1

# menu
install -D -m 644 %{name}-16.png $RPM_BUILD_ROOT%{_miconsdir}/%{name}.png
install -D -m 644 %{name}-32.png $RPM_BUILD_ROOT%{_iconsdir}/%{name}.png
install -D -m 644 %{name}-48.png $RPM_BUILD_ROOT%{_liconsdir}/%{name}.png

install -d $RPM_BUILD_ROOT%{_menudir}
cat << EOF > $RPM_BUILD_ROOT%{_menudir}/%{name}
?package(%{name}): \
	command="%{_bindir}/%{name}" \
	icon="%{name}.png" \
	needs="x11" \
	section="Multimedia/Video" \
	title="%{Name}" \
	longtitle="%{summary1}"
EOF

install -d $RPM_BUILD_ROOT%{_menudir}
cat << EOF > $RPM_BUILD_ROOT%{_menudir}/%{name}_wizard
?package(%{name}): \
	command="%{_bindir}/%{name}_wizard" \
	icon="%{name}.png" \
	needs="x11" \
	section="Multimedia/Video" \
	title="%{Name}_Wizard" \
	longtitle="%{summary1}"
EOF

%clean
rm -rf $RPM_BUILD_ROOT

%post
%{update_menus}
/sbin/modprobe -r bttv
%{_sbindir}/update-alternatives --install %{tvtuner_launcher}/kde.desktop tvtuner.kde.dynamic %{tvtuner_launcher}/%{name}.desktop 100
%{_sbindir}/update-alternatives --install %{tvtuner_launcher}/gnome.desktop tvtuner.gnome.dynamic %{tvtuner_launcher}/%{name}.desktop 100
/sbin/modprobe bttv

%postun
%{clean_menus}
if [ $1 = 0 ]; then
  /sbin/modprobe -r bttv
  %{_sbindir}/update-alternatives --remove tvtuner.kde.dynamic %{tvtuner_launcher}/%{name}.desktop
  %{_sbindir}/update-alternatives --remove tvtuner.gnome.dynamic %{tvtuner_launcher}/%{name}.desktop
  /sbin/modprobe bttv
fi

%files
%defattr(-,root,root)
%doc AUTHORS ChangeLog COPYING FAQfr-xawdecode libavc-rate-control.txt
%doc lircrc.hauppauge.sample lircrc.miro.sample lisez-moi README.avilib
%doc xawdecoderc.sample INSTALL README README.deinterlace README.ffmpeg
%doc lircrc.animax.sample README.bs
%config(noreplace) %{tvtuner_launcher}/%{name}.desktop
%{_sysconfdir}/X11/app-defaults/%{Name}
%{_sysconfdir}/%{name}_wizard.conf
%{_bindir}/%{name}
%{_bindir}/%{name}_cmd
%{_bindir}/%{name}_wizard
%{_bindir}/scan.sh
%{_mandir}/man1/*
%{_menudir}/%{name}
%{_menudir}/%{name}_wizard
%{_iconsdir}/%{name}.png
%{_miconsdir}/%{name}.png
%{_liconsdir}/%{name}.png

%files devel
%defattr(-,root,root)
%{_includedir}/*

%files v4l-conf
%defattr(-,root,root)
%{_bindir}/v4l-conf

%files OSD-font
%defattr(-,root,root)
%{_prefix}/X11R6/lib/X11/fonts/misc/led-fixed.pcf

%changelog
* Mon Jul 7 2003 Pingus <pingus77@ifrance.com> 1.7.0-1mdk
- ver 1.7.0
- plenty of modifications for this spec file

* Fri May 2 2003 Pingus <pingus77@ifrance.com> 1.6.8-1mdk
- ver 1.6.8
- plenty of modifications for this spec file

* Fri Jan 25 2003 Pingus <pingus77@ifrance.com>
- ver 1.6.7
- OSD-font sample package
- enable-nextaw

* Tue Jan 02 2003 Pingus <pingus77@ifrance.com>
- ver 1.6.6a with v4l-conf sample package
- big big errors in menu and icons

* Fri Nov 18 2002 Pingus <pingus77@ifrance.com>
- ver 1.6.6a special sourceforge release

* Mon Nov 13 2002 Pingus <pingus77@ifrance.com>
- ver 1.6.6

* Tue Oct 26 2002 Pingus <pingus77@ifrance.com>
- add lirc support
- add menus entry
- made spec file more mdk compatible (define, mandir)

* Wed Oct 18 2002 Pingus <pingus77@ifrance.com>
- ver 1.6.5
- Adaptation for Mandrake 9.0 based on Laurent Culioli <laurent@pschit.net> spec file
- include last patches from keuleu
